#include "gproc.h"


/*  mise a jour du label contenant le nombre de process en cours    */
gint update_applet_label(gpointer data)
{
    gchar *label_text;

    label_text=(gchar*)malloc(sizeof(gchar[6]));

    sprintf(label_text,"%d",count_proc());
    gtk_label_set(GTK_LABEL(app->label),label_text);

    free(label_text);
    label_text=NULL;
    return 1;
}



/*  on change l'orientation du panel... */
gint change_orient(GtkWidget *widget, gpointer data)
{
	return change_geometry(widget, data);
}



#ifdef CVS_VERSION
/*  on change la taille du panel... */
gint change_size(GtkWidget *widget, gpointer data)
{
    return change_geometry(widget, data);
}
#endif



/*	on effectue le changement de l'applet	*/
gint change_geometry(GtkWidget *widget, gpointer data)
{
	pattr->orient=applet_widget_get_panel_orient(APPLET_WIDGET(app->applet));

#ifdef CVS_VERSION
	pattr->size=applet_widget_get_panel_size(APPLET_WIDGET(app->applet));
#endif
	
	
	if(pattr->orient==ORIENT_UP || pattr->orient==ORIENT_DOWN)
	{
#ifdef CVS_VERSION	
		if(pattr->size==SIZE_TINY)
		{
			app->label=app->hlabel;
            gtk_widget_hide(app->vframe);
            gtk_widget_show(app->hframe);
		}
		else
		{
			app->label=app->vlabel;
			gtk_widget_hide(app->hframe);
			gtk_widget_show(app->vframe);
		}
#else
			app->label=app->vlabel;
			gtk_widget_hide(app->hframe);
			gtk_widget_show(app->vframe);
#endif

	}
    else
	{

#ifdef CVS_VERSION
		if(pattr->size==SIZE_TINY)
		{
			app->label=app->vlabel;
            gtk_widget_hide(app->hframe);
            gtk_widget_show(app->vframe);
		}
		else
		{
			app->label=app->hlabel;
			gtk_widget_hide(app->vframe);
			gtk_widget_show(app->hframe);
		}
#else
			app->label=app->hlabel;
			gtk_widget_hide(app->vframe);
			gtk_widget_show(app->hframe);
#endif

	}

    return 1;

}




/* interface pour applet */
gint create_gproc_applet(void)
{
	GtkWidget *vbutton,*hbutton,*vbutton_pixmap,*hbutton_pixmap;
    GtkWidget *vbox,*hbox;
    GtkWidget *vlabelframe,*hlabelframe,*hframe,*vframe;
    GtkWidget *vlabel,*hlabel;
    GtkWidget *base;
    GdkPixmap *pix;
    GdkBitmap *mask;



    /*  attributs du panel  */
    pattr=g_new(PanelAttrib,1);
    pattr->orient=applet_widget_get_panel_orient(APPLET_WIDGET(app->applet));

#ifdef CVS_VERSION
    pattr->size=applet_widget_get_panel_size(APPLET_WIDGET(app->applet));
#endif

    /*  bouton  */
    vbutton=gtk_button_new();
    gtk_widget_set_usize(GTK_WIDGET(vbutton),23 , 23);
    gtk_signal_connect(GTK_OBJECT(vbutton),"button_press_event",GTK_SIGNAL_FUNC(main_btn_clicked),NULL);
    GTK_WIDGET_UNSET_FLAGS(vbutton, GTK_CAN_DEFAULT);
    GTK_WIDGET_UNSET_FLAGS(vbutton, GTK_CAN_FOCUS);
    hbutton=gtk_button_new();
    gtk_widget_set_usize(GTK_WIDGET(hbutton),23 , 23);
    gtk_signal_connect(GTK_OBJECT(hbutton),"button_press_event",GTK_SIGNAL_FUNC(main_btn_clicked),NULL);
    GTK_WIDGET_UNSET_FLAGS(hbutton, GTK_CAN_DEFAULT);
    GTK_WIDGET_UNSET_FLAGS(hbutton, GTK_CAN_FOCUS);


    /*  pixmap  */
    pix=gdk_pixmap_create_from_xpm((app->applet)->window,&mask,NULL, GPROC_DIR "icons/gproc-pixmap.xpm");
    vbutton_pixmap=gtk_pixmap_new(pix,mask);
    gtk_container_add(GTK_CONTAINER(vbutton),vbutton_pixmap);
    hbutton_pixmap=gtk_pixmap_new(pix,mask);
    gtk_container_add(GTK_CONTAINER(hbutton),hbutton_pixmap);


    /*  frames  */
    vframe=gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(vframe),GTK_SHADOW_IN);
    hframe=gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(hframe),GTK_SHADOW_IN);
    vlabelframe=gtk_frame_new(NULL);
    hlabelframe=gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(vlabelframe),GTK_SHADOW_IN);
    gtk_frame_set_shadow_type(GTK_FRAME(hlabelframe),GTK_SHADOW_IN);

    /*  boites  */
    base=gtk_vbox_new(FALSE,0);
    hbox=gtk_hbox_new(FALSE,1);
    vbox=gtk_vbox_new(FALSE,1);
    /*  label   */
    vlabel=gtk_label_new(NULL);
    gtk_container_add(GTK_CONTAINER(vlabelframe),vlabel);
    hlabel=gtk_label_new(NULL);
    gtk_container_add(GTK_CONTAINER(hlabelframe),hlabel);



    /*  Mise en place des widgets pour un paneau en haut ou en bas  */
    gtk_box_pack_start(GTK_BOX(vbox),vbutton,TRUE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(vbox),vlabelframe,FALSE,FALSE,0);
    gtk_container_add(GTK_CONTAINER(vframe),vbox);
    gtk_box_pack_start(GTK_BOX(base),vframe,FALSE,FALSE,0);

    /* Mise en place des widgets pour un paneau a gauche ou a droite    */
    gtk_box_pack_start(GTK_BOX(hbox),hbutton,TRUE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(hbox),hlabelframe,FALSE,FALSE,0);
    gtk_container_add(GTK_CONTAINER(hframe),hbox);
    gtk_box_pack_start(GTK_BOX(base),hframe,FALSE,FALSE,0);


    gtk_widget_show(vbutton);
    gtk_widget_show(hbutton);
    gtk_widget_show(vlabel);
    gtk_widget_show(hlabel);
    gtk_widget_show(vbutton_pixmap);
    gtk_widget_show(hbutton_pixmap);
    gtk_widget_show(hbox);
    gtk_widget_show(vbox);
    gtk_widget_show(vlabelframe);
    gtk_widget_show(hlabelframe);
    gtk_widget_show(base);

    app->vbutton=vbutton;
    app->hbutton=hbutton;
    app->vlabel=vlabel;
    app->hlabel=hlabel;
    app->vbutton_pixmap=vbutton_pixmap;
    app->hbutton_pixmap=hbutton_pixmap;
    app->hbox=hbox;
    app->vbox=vbox;
    app->vframe=vframe;
    app->hframe=hframe;

    if(pattr->orient==ORIENT_UP || pattr->orient==ORIENT_DOWN)
    {
#ifdef CVS_VERSION
        if(pattr->size==SIZE_TINY)
        {
            app->label=app->hlabel;
            gtk_widget_show(hframe);
        }
        else
        {
            app->label=app->vlabel;
            gtk_widget_show(vframe);
        }
#else
            app->label=app->vlabel;
            gtk_widget_show(vframe);
#endif

    }
    else
    {
#ifdef CVS_VERSION
        if(pattr->size==SIZE_TINY)
        {
            app->label=app->vlabel;
            gtk_widget_show(vframe);
        }
        else
        {
            app->label=app->hlabel;
            gtk_widget_show(hframe);
        }
#else
            app->label=app->hlabel;
            gtk_widget_show(hframe);
#endif

    }

    applet_widget_add(APPLET_WIDGET(app->applet),base);

    applet_widget_register_stock_callback(APPLET_WIDGET(app->applet),
                                        "about",
                                        GNOME_STOCK_MENU_ABOUT,
                                      _("About..."),
                                        (AppletCallbackFunc)about_cb,
                                        NULL);
     applet_widget_register_stock_callback(APPLET_WIDGET(app->applet),
                                        "properties",
                                        GNOME_STOCK_MENU_PROP,
                                      _("Properties..."),
                                        (AppletCallbackFunc)properties_cb,
                                        NULL);
     applet_widget_register_stock_callback (APPLET_WIDGET(app->applet),
                                        "run_gtop",
                                        GNOME_STOCK_MENU_INDEX,
                                        _("Run gtop..."),
                                        (AppletCallbackFunc)start_gtop, NULL);

    applet_widget_set_tooltip(APPLET_WIDGET(app->applet),"Process Management");


    gtk_signal_connect(GTK_OBJECT(app->applet),"save_session",GTK_SIGNAL_FUNC(save_gproc_config),NULL);

	return TRUE;
}

