#include "gproc.h"





/*	chargement config par defaut	*/
void load_default_config(void)
{
	prop->posX=0;
	prop->posY=0;
	prop->orient=ORIENT_VERT;
	prop->owner_uid_filter=-1;
	prop->owner_name_filter_pressed=0;
	prop->owner_name_filter_static=strdup("none");
	if (prop->owner_name_filter_pressed)
		prop->owner_name_filter = prop->owner_name_filter_static;
	prop->compt_all=0;
	prop->tree_view=1;
	prop->expand_tree=1;
	prop->refresh_label=1;
	prop->refresh_clist=1;
	prop->refresh_ctree=1;
	prop->popup_height=400;
	prop->popup_width=320;
	prop->sort_type=0;
	prop->last_clicked_column=0;
	prop->close_popup_after_sig=0;
	prop->skin_path=strdup( GPROC_DIR "skins/Default/");
	prop->show_help=1;
	prop->short_proc_state=1;
}



/*	extract ligne de config	gchar*/
gchar *extract_config_gchar(gchar *fichier, gchar *chaine, gchar *defaut)
{
	gchar buf[120];
    gchar *s,*arg;
	FILE *file;

	file=fopen(fichier,"r");

	while (fgets(buf, sizeof(buf), file))
	{
		s=strtok(buf," \t:=\n");
		if ( s==NULL || *s=='@' || *s=='\n' || *s=='\0' )
			 continue;
		if(strcmp(s,chaine)==0)
		{
			
			arg = strtok(NULL, "\n@");

			if(strcmp(arg,"\n")==0)
			{
				fclose(file);
				return strdup(defaut);
			}
				
			fclose(file);
			return strdup(arg);
		}
	};
	
	fclose(file);
	return strdup(defaut);
	
}




/*	lecture de .gprocrc	*/
void read_gproc_config(void)
{
	
	gchar *config_dir;	
	gchar config_file[50];
	gchar skins_dir[50];
    struct passwd *pw;
    FILE *file;

    pw=getpwuid(getuid());
    config_dir=pw->pw_dir;
	config_dir=strcat(config_dir,"/.gproc/");
	sprintf(config_file,"%sgproc-config",config_dir);
	sprintf(skins_dir,"%sskins/",config_dir);


	if( opendir(config_dir) == NULL )
		mkdir(config_dir,0775);

	if( opendir(skins_dir) == NULL )
		mkdir(skins_dir,0775);

	
	if( (file=fopen(config_file,"r"))==NULL)
	{
		load_default_config();
		save_gproc_config();
	}
	else
	{
		
		fclose(file);
		prop->posX=atoi(extract_config_gchar(config_file,"posX","0"));
		prop->posY=atoi(extract_config_gchar(config_file,"posY","0"));
		prop->orient=atoi(extract_config_gchar(config_file,"orient","1"));
		prop->owner_uid_filter=atoi(extract_config_gchar(config_file,"owner_uid_filter","-1"));
		prop->owner_name_filter_pressed=atoi(extract_config_gchar(config_file,"name_filter_pressed","0"));
		prop->owner_name_filter_static=extract_config_gchar(config_file,"owner_name_filter_static","none");
		prop->compt_all=atoi(extract_config_gchar(config_file,"compt_all","0"));
		prop->tree_view=atoi(extract_config_gchar(config_file,"tree_view","1"));
		prop->expand_tree=atoi(extract_config_gchar(config_file,"expand_tree","1"));
		prop->refresh_label=atoi(extract_config_gchar(config_file,"refresh_label","1"));
		prop->refresh_clist=atoi(extract_config_gchar(config_file,"refresh_clist","1"));	
		prop->refresh_ctree=atoi(extract_config_gchar(config_file,"refresh_ctree","1"));	
		prop->popup_height=atoi(extract_config_gchar(config_file,"popup_height","400"));
		prop->popup_width=atoi(extract_config_gchar(config_file,"popup_width","320"));
		prop->last_clicked_column=atoi(extract_config_gchar(config_file,"last_clicked_column","0"));
		prop->sort_type=atoi(extract_config_gchar(config_file,"sort_type","0"));
		prop->close_popup_after_sig=atoi(extract_config_gchar(config_file,"close_popup_after_sig","0"));
		prop->skin_path=extract_config_gchar(config_file,"skin_path","/usr/local/gproc/skins/Default");		
		prop->show_help=atoi(extract_config_gchar(config_file,"show_help","1"));		
		prop->short_proc_state=atoi(extract_config_gchar(config_file,"short_proc_state","1"));
		if (prop->owner_name_filter_pressed)
			prop->owner_name_filter = prop->owner_name_filter_static;
	}

}

void save_gproc_config()
{
    FILE *file;
	gchar *config_file;
	struct passwd *pw;
	
    pw=getpwuid(getuid());
    config_file=pw->pw_dir;
    strcat(config_file,"/.gproc/gproc-config");
	
	if( (file=fopen(config_file,"w"))==NULL)
	{
		creat(config_file,0664);
		file=fopen(config_file,"w");
	}
	
	fprintf(file,"@ GPROC %s config \n",VERSION);
	fprintf(file,"@ AUTOWRITEN, DO NOT EDIT \n\n");
	fprintf(file,"posX:%d\n",prop->posX);
	fprintf(file,"posY:%d\n",prop->posY);
	fprintf(file,"orient:%d\n",prop->orient);
	fprintf(file,"owner_uid_filter:%d\n",prop->owner_uid_filter);
	fprintf(file,"name_filter_pressed:%d\n",prop->owner_name_filter_pressed);
	fprintf(file,"owner_name_filter_static:%s\n",prop->owner_name_filter_static);
	fprintf(file,"compt_all:%d\n",prop->compt_all);
	fprintf(file,"tree_view:%d\n",prop->tree_view);
	fprintf(file,"expand_tree:%d\n",prop->expand_tree);
	fprintf(file,"refresh_label:%d\n",prop->refresh_label);
	fprintf(file,"refresh_clist:%d\n",prop->refresh_clist);
	fprintf(file,"refresh_ctree:%d\n",prop->refresh_ctree);
	fprintf(file,"popup_height:%d\n",prop->popup_height);
	fprintf(file,"popup_width:%d\n",prop->popup_width);
	fprintf(file,"last_clicked_column:%d\n",prop->last_clicked_column);
	fprintf(file,"sort_type:%d\n",prop->sort_type);
	fprintf(file,"close_popup_after_sig:%d\n",prop->close_popup_after_sig);
	fprintf(file,"skin_path:%s\n",prop->skin_path);
	fprintf(file,"show_help:%d\n",prop->show_help);
	fprintf(file,"short_proc_state:%d\n",prop->short_proc_state);
	fclose(file);

}







/* fenetre de proprietes (Basee sur celle de GIMP)    */
GtkWidget* file_prefs_notebook_append_page (GtkNotebook   *notebook,
													gchar *notebook_label,
													GtkCTree *ctree,
													gchar *tree_label,
													GtkCTreeNode *parent,
													GtkCTreeNode **new_node,
													gint page_index)
{
	GtkWidget *out_vbox;
	GtkWidget *vbox;
	GtkWidget *frame;
	GtkWidget *label;
	gchar *titles[1];

	out_vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (out_vbox);

	frame = gtk_frame_new (NULL);
	gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_OUT);
	gtk_box_pack_start (GTK_BOX (out_vbox), frame, FALSE, TRUE, 0);
	gtk_widget_show (frame);

	label = gtk_label_new (notebook_label);
	gtk_misc_set_alignment (GTK_MISC (label), 0.0, 0.5);
	gtk_misc_set_padding (GTK_MISC (label), 2, 1);
	gtk_container_add (GTK_CONTAINER (frame), label);
	gtk_widget_show (label);

	vbox = gtk_vbox_new (FALSE, 2);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 4);
	gtk_container_add (GTK_CONTAINER (out_vbox), vbox);
	gtk_widget_show (vbox);

	titles[0] = tree_label;
	*new_node = gtk_ctree_insert_node (ctree, parent, NULL,
                     titles, 0,
                     NULL, NULL, NULL, NULL,
                     FALSE, FALSE);
	gtk_ctree_node_set_row_data (ctree,*new_node, (gpointer) page_index);
	gtk_notebook_append_page (notebook, out_vbox, NULL);

	return vbox;
}



/*  selectionne une page du notebook */
void file_pref_tree_select_callback (GtkWidget *widget, GtkCTreeNode *node)
{
	GtkNotebook *notebook;
	gint page;

	if (!GTK_CLIST (widget)->selection)
		return;

	notebook = (GtkNotebook*) gtk_object_get_user_data (GTK_OBJECT (widget));
	page = (gint) gtk_ctree_node_get_row_data (GTK_CTREE (widget), node);

	gtk_notebook_set_page (notebook, page);
}
   



/* affichage du panneau de config */
void properties_cb(void *data)
{
	
	GtkWidget *ctree;
#ifndef APPLET
	gchar *skins_clist_titles[]={"Skin Name","Directory"};
	GtkWidget *skins_clist;
	GtkWidget *scrolled;
#endif
	gchar buf[525];
	gchar *titles[1];
	GtkCTreeNode *top_insert;
	GtkCTreeNode *child_insert;
	gint page_index;
	GtkWidget *button;
	GtkWidget *cadre;
	GtkWidget *frame;
	GtkWidget *notebook;
	GtkWidget *vbox;
	GtkWidget *vbox2;
	GtkWidget *hbox;
	GtkWidget *hbox2;
	GtkWidget *tbox;
	GtkWidget *tframe;
	GtkWidget *label;
	GtkWidget *radiobtn;
	GtkObject *adj;
	GdkPixmap *pix;
	GdkBitmap *mask;
	GtkWidget *icon;
	gint scrX,scrY;
	gchar home_skins_dir[50];
    struct passwd *pw;

    pw=getpwuid(getuid());
    strcpy(home_skins_dir,pw->pw_dir);
    strcat(home_skins_dir,HOME_SKINS_DIR);

	scrX=gdk_screen_width();
	scrY=gdk_screen_height();

	
	if(prop_window)
	{
		gdk_window_raise((prop_window->win)->window);
		return;
	}
	prop_window=g_new(properties_window,1);
	
	prop_window->win=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_realize(prop_window->win);
	pix=gdk_pixmap_create_from_xpm(prop_window->win->window,&mask,NULL, GPROC_DIR "icons/gproc-icon.xpm");
    gdk_window_set_icon(prop_window->win->window,NULL,pix,mask);
	gtk_window_set_policy(GTK_WINDOW(prop_window->win),FALSE,FALSE,TRUE);
	gtk_widget_set_uposition(prop_window->win,scrX/2-250,scrY/2-100);
	gtk_signal_connect(GTK_OBJECT(prop_window->win),"delete_event",GTK_SIGNAL_FUNC(destroy_properties_cb),NULL);
	gtk_window_set_title(GTK_WINDOW(prop_window->win),"GProc Configuration");

	vbox=gtk_vbox_new(FALSE,5);
	gtk_widget_show(vbox);
	gtk_container_add(GTK_CONTAINER(prop_window->win),vbox);
	prop_window->vbox=gtk_vbox_new(FALSE,5);
	gtk_widget_show(prop_window->vbox);
	gtk_box_pack_start(GTK_BOX(vbox),prop_window->vbox,TRUE,TRUE,0);
	prop_window->action_area=gtk_vbox_new(FALSE,5);
    gtk_widget_show(prop_window->action_area);
    gtk_box_pack_start(GTK_BOX(vbox),prop_window->action_area,TRUE,TRUE,10);

	
	/*	boite horiz principale	*/
	hbox=gtk_hbox_new(FALSE,6);
	gtk_container_set_border_width(GTK_CONTAINER(hbox),6);
	gtk_box_pack_start(GTK_BOX(prop_window->vbox),hbox, TRUE, TRUE, 0);
	gtk_widget_show(hbox);

	/*	Le tree de menu	*/
	titles[0]="Categories";
	ctree=gtk_ctree_new_with_titles (1,0,titles);
	gtk_ctree_set_indent(GTK_CTREE(ctree),15);
	gtk_clist_column_titles_passive(GTK_CLIST(ctree));
	gtk_widget_set_usize(ctree,140,0);
	gtk_box_pack_start (GTK_BOX(hbox),ctree,FALSE,FALSE,0);
	gtk_widget_show(ctree);


	/*	preference notebook	*/
	frame=gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_IN);
	gtk_box_pack_start(GTK_BOX(hbox),frame,TRUE,TRUE,0);
	gtk_widget_show(frame);

	notebook=gtk_notebook_new();
	gtk_notebook_set_show_tabs(GTK_NOTEBOOK(notebook),FALSE);
	gtk_notebook_set_show_border(GTK_NOTEBOOK (notebook),FALSE);
	gtk_container_add(GTK_CONTAINER(frame),notebook);

	gtk_object_set_user_data(GTK_OBJECT(ctree),notebook);
	gtk_signal_connect(GTK_OBJECT (ctree),"tree_select_row",(GtkSignalFunc)file_pref_tree_select_callback,NULL);

	page_index = 0;


	/*	PAGE PRINCIPALE	*/
	vbox = file_prefs_notebook_append_page (GTK_NOTEBOOK (notebook),
                      "General Settings",
                      GTK_CTREE (ctree),
                      "General",
                      NULL,
                      &top_insert,
                      page_index);
	
	gtk_widget_show(notebook);
	gtk_widget_show(vbox);
	
	page_index++;
	gtk_ctree_select (GTK_CTREE (ctree), top_insert);

	
	
	
	hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
    gtk_widget_show(hbox2);
    prop_window->check_close_popup_after_sig=gtk_check_button_new_with_label("Close popup window after the signal emission");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(prop_window->check_close_popup_after_sig),prop->close_popup_after_sig);
    gtk_box_pack_start(GTK_BOX(hbox2),prop_window->check_close_popup_after_sig,FALSE,FALSE,5);
    gtk_widget_show(prop_window->check_close_popup_after_sig);

	hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
    gtk_widget_show(hbox2);
    prop_window->check_short_proc_state=gtk_check_button_new_with_label("Display short process's state (ie: R=Running)");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(prop_window->check_short_proc_state),prop->short_proc_state);
    gtk_box_pack_start(GTK_BOX(hbox2),prop_window->check_short_proc_state,FALSE,FALSE,5);
    gtk_widget_show(prop_window->check_short_proc_state);

	
/*
   gtk_signal_connect_object(GTK_OBJECT(prop_window->check_close_popup_after_sig),
   							"toggled",GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
*/
    hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
    gtk_widget_show(hbox2);
    prop_window->button_tree=gtk_button_new_with_label("Change the type of view");
    gtk_box_pack_start(GTK_BOX(hbox2),prop_window->button_tree,FALSE,FALSE,5);
    gtk_widget_show(prop_window->button_tree);
    tframe=gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(tframe),GTK_SHADOW_ETCHED_OUT);
    gtk_widget_show(tframe);
    tbox=gtk_hbox_new(FALSE,5);
    gtk_widget_show(tbox);
    gtk_container_add(GTK_CONTAINER(tframe),tbox);
    prop_window->label_button_tree=gtk_label_new("Type of view");
    gtk_box_pack_start(GTK_BOX(tbox),prop_window->label_button_tree,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(hbox2),tframe,FALSE,FALSE,5);
    gtk_widget_show(prop_window->label_button_tree);
    prop_window->temp_tree_view=prop->tree_view;
    prop_tree_label();
    gtk_signal_connect_object(GTK_OBJECT(prop_window->button_tree),"clicked",GTK_SIGNAL_FUNC(prop_tree_choice),NULL);
/*    
	gtk_signal_connect_object(GTK_OBJECT(prop_window->button_tree),
							"clicked",GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
*/	
	
	hbox2=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
	gtk_widget_show(hbox2);
	label=gtk_label_new("Process update rate (in seconds)");
	gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,5);	
	gtk_widget_show(label);
	adj=gtk_adjustment_new(prop->refresh_label,1.0,30.0,1,1,1);
	prop_window->spin_label=gtk_spin_button_new(GTK_ADJUSTMENT(adj),1,0);
	gtk_box_pack_start(GTK_BOX(hbox2),prop_window->spin_label,FALSE,FALSE,5);
	gtk_widget_show(prop_window->spin_label);

	
	
/*
   gtk_signal_connect_object(GTK_OBJECT(prop_window->check_close_popup_after_sig),
   							"toggled",GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));

    hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
    gtk_widget_show(hbox2);
    prop_window->button_tree=gtk_button_new_with_label("Change

	gtk_signal_connect_object(GTK_OBJECT(adj),
							"value_changed",GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
	gtk_signal_connect_object(GTK_OBJECT(prop->spin_label),
							"changed",GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
*/

	/*	ROOT PRIVILEGES PAGE	*/
	/*
	vbox = file_prefs_notebook_append_page (GTK_NOTEBOOK (notebook),
                      "Root Priveleges",
                      GTK_CTREE (ctree),
                      "Root Privileges",
                      top_insert,
                      &child_insert,
                      page_index);
	gtk_widget_show (vbox);
	page_index++;


	hbox2=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
	gtk_widget_show(hbox2);
	*/

	/*	GProc geometry	*/
	 vbox = file_prefs_notebook_append_page (GTK_NOTEBOOK (notebook),
                      "GProc Geometry",
                      GTK_CTREE (ctree),
                      "Geometry",
                      top_insert,
                      &child_insert,
                      page_index);
	gtk_ctree_expand(GTK_CTREE(ctree),top_insert);
	gtk_widget_show (vbox);
  	page_index++;


#ifndef APPLET
	hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
    gtk_widget_show(hbox2);
    prop_window->button_orient=gtk_button_new_with_label("Orientation of GProc");
    gtk_box_pack_start(GTK_BOX(hbox2),prop_window->button_orient,FALSE,FALSE,5);
    gtk_widget_show(prop_window->button_orient);
    tframe=gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(tframe),GTK_SHADOW_ETCHED_OUT);
    gtk_widget_show(tframe);
    tbox=gtk_hbox_new(FALSE,5);
    gtk_widget_show(tbox);
    gtk_container_add(GTK_CONTAINER(tframe),tbox);
    prop_window->label_button_orient=gtk_label_new("Orientation");
    gtk_box_pack_start(GTK_BOX(tbox),prop_window->label_button_orient,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(hbox2),tframe,FALSE,FALSE,5);
    gtk_widget_show(prop_window->label_button_orient);
	prop_window->temp_orient=prop->orient;
    prop_orient_label();
    gtk_signal_connect_object(GTK_OBJECT(prop_window->button_orient),"clicked",GTK_SIGNAL_FUNC(prop_orient_choice),NULL);

/*
	gtk_signal_connect_object(GTK_OBJECT(prop_window->button_orient),
							"clicked",GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
*/

	
	cadre=gtk_frame_new("GProc position at restart");
    gtk_widget_show(cadre);
    tbox=gtk_vbox_new(FALSE,5);
    gtk_widget_show(tbox);
	hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(tbox),hbox2,FALSE,FALSE,5);
    gtk_widget_show(hbox2);
    label=gtk_label_new("X:");
    gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,5);
    gtk_widget_show(label);
    prop_window->label_posX=gtk_entry_new_with_max_length(4);
	sprintf(buf,"%d",prop->posX);
	gtk_entry_set_text(GTK_ENTRY(prop_window->label_posX),buf);
	gtk_box_pack_start(GTK_BOX(hbox2),prop_window->label_posX,FALSE,FALSE,5);
    gtk_widget_show(prop_window->label_posX);
    label=gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,5);
    gtk_widget_show(label);
	prop_window->label_posY=gtk_entry_new_with_max_length(4);
	sprintf(buf,"%d",prop->posY);
    gtk_entry_set_text(GTK_ENTRY(prop_window->label_posY),buf);
    gtk_box_pack_start(GTK_BOX(hbox2),prop_window->label_posY,FALSE,FALSE,5);
    gtk_widget_show(prop_window->label_posY);
	
	hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(tbox),hbox2,FALSE,FALSE,5);
    gtk_widget_show(hbox2);
    button=gtk_button_new_with_label("Retreive GProc position NOW !");
	gtk_widget_show(button);
	gtk_box_pack_start(GTK_BOX(hbox2),button,FALSE,FALSE,5);
    gtk_signal_connect_object(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(retreive_gproc_position),NULL);

	
	gtk_container_add(GTK_CONTAINER(cadre),tbox);
    gtk_box_pack_start(GTK_BOX(vbox),cadre,FALSE,FALSE,15);

	
#endif

	cadre=gtk_frame_new("Process window size");
    gtk_widget_show(cadre);
    tbox=gtk_vbox_new(FALSE,5);
    gtk_widget_show(tbox);

    hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(tbox),hbox2,FALSE,FALSE,5);
    gtk_widget_show(hbox2);
    label=gtk_label_new("Width:");
    gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,5);
    gtk_widget_show(label);
    adj=gtk_adjustment_new(prop->popup_width,100.0,1000.0,1,1,1);
    prop_window->spin_popup_width=gtk_spin_button_new(GTK_ADJUSTMENT(adj),1,0);
    gtk_box_pack_start(GTK_BOX(hbox2),prop_window->spin_popup_width,FALSE,FALSE,5);
    gtk_widget_show(prop_window->spin_popup_width);
/*
   	gtk_signal_connect_object(GTK_OBJECT(adj),"value_changed",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
	gtk_signal_connect_object(GTK_OBJECT(prop->spin_popup_width),"changed",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),GTK_OBJECT(prop->window));
*/

    hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(tbox),hbox2,FALSE,FALSE,5);
    gtk_widget_show(hbox2);
    label=gtk_label_new("Height");
    gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,5);
    gtk_widget_show(label);
    adj=gtk_adjustment_new(prop->popup_height,100.0,1200.0,1,1,1);
    prop_window->spin_popup_height=gtk_spin_button_new(GTK_ADJUSTMENT(adj),1,0);
    gtk_box_pack_start(GTK_BOX(hbox2),prop_window->spin_popup_height,FALSE,FALSE,5);
    gtk_widget_show(prop_window->spin_popup_height);
/*
	gtk_signal_connect_object(GTK_OBJECT(adj),"value_changed",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
	gtk_signal_connect_object(GTK_OBJECT(prop->spin_popup_height),"changed",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),GTK_OBJECT(prop->window));
*/
    gtk_container_add(GTK_CONTAINER(cadre),tbox);
    gtk_box_pack_start(GTK_BOX(vbox),cadre,FALSE,FALSE,15);



	
	/*	TREEVIEW PAGE	*/
	 vbox = file_prefs_notebook_append_page (GTK_NOTEBOOK (notebook),
                      "TreeView Settings",
                      GTK_CTREE (ctree),
                      "TreeView",
                      NULL,
                      &top_insert,
                      page_index);
  gtk_widget_show (vbox);
  page_index++;


	hbox2=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
	gtk_widget_show(hbox2);
	prop_window->check_expand_tree=gtk_check_button_new_with_label("Automatically expand the TreeView");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(prop_window->check_expand_tree),prop->expand_tree);
	gtk_box_pack_start(GTK_BOX(hbox2),prop_window->check_expand_tree,FALSE,FALSE,5);
	gtk_widget_show(prop_window->check_expand_tree);
/*
	gtk_signal_connect_object(GTK_OBJECT(prop->check_expand_tree),"toggled",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
*/

	
	hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
    gtk_widget_show(hbox2);
    label=gtk_label_new("Refresh process tree every");
    gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,5);
    gtk_widget_show(label);
    adj=gtk_adjustment_new(prop->refresh_ctree,1.0,30.0,1,1,1);
    prop_window->spin_tree=gtk_spin_button_new(GTK_ADJUSTMENT(adj),1,0);
    gtk_box_pack_start(GTK_BOX(hbox2),prop_window->spin_tree,FALSE,FALSE,5);
    gtk_widget_show(prop_window->spin_tree);
/*
	gtk_signal_connect_object(GTK_OBJECT(adj),"value_changed",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
	gtk_signal_connect_object(GTK_OBJECT(prop->spin_tree),"changed",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
*/
    label=gtk_label_new("seconds");
    gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,5);
    gtk_widget_show(label);


	/*	CLIST PAGE	*/

	vbox = file_prefs_notebook_append_page (GTK_NOTEBOOK (notebook),
                      "ListView Settings",
                      GTK_CTREE (ctree),
                      "ListView",
                      NULL,
                      &top_insert,
                      page_index);
  gtk_widget_show (vbox);
  page_index++;

	
	hbox2=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
	gtk_widget_show(hbox2);

	hbox2=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(vbox),hbox2, FALSE, FALSE, 5);
	gtk_widget_show(hbox2);
	radiobtn = gtk_radio_button_new_with_label(NULL, "Show all processes");
	gtk_box_pack_start(GTK_BOX(hbox2),radiobtn, FALSE, FALSE, 5);
	gtk_widget_show(radiobtn);

	hbox2=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(vbox),hbox2, FALSE, FALSE, 5);
	gtk_widget_show(hbox2);
	prop_window->filter = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(radiobtn)), "Show processes owned by user");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(prop_window->filter),prop->owner_name_filter_pressed);
	gtk_box_pack_start(GTK_BOX(hbox2),prop_window->filter, FALSE, FALSE, 5);
	gtk_widget_show(prop_window->filter);
/*
	gtk_signal_connect_object(GTK_OBJECT(prop->filter),"toggled",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
*/
	prop_window->edit=gtk_entry_new_with_max_length(255);
	gtk_entry_set_text(GTK_ENTRY(prop_window->edit),prop->owner_name_filter_static);
	gtk_box_pack_start(GTK_BOX(hbox2),prop_window->edit,FALSE,FALSE,5);
	gtk_widget_show(prop_window->edit);
/*	
	gtk_signal_connect_object(GTK_OBJECT(prop_window->edit),"changed",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
*/

	hbox2 = gtk_hbox_new(FALSE,1);
	gtk_widget_show(hbox2);
	gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,1);
	cadre = gtk_frame_new(NULL);
	gtk_widget_show(cadre);
	vbox2 = gtk_vbox_new(FALSE,5);
	gtk_widget_show(vbox2);
	gtk_container_add(GTK_CONTAINER(cadre),vbox2);
	radiobtn = gtk_radio_button_new_with_label(NULL, "Count processes for user");
	gtk_widget_show(radiobtn);
	gtk_box_pack_start(GTK_BOX(vbox2),radiobtn, FALSE, FALSE, 1);
	prop_window->check_count_all = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(radiobtn)), "Count all processes");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(prop_window->check_count_all),prop->compt_all);
	gtk_box_pack_start(GTK_BOX(vbox2),prop_window->check_count_all, FALSE, FALSE, 1);
	gtk_widget_show(prop_window->check_count_all);
/*
	gtk_signal_connect_object(GTK_OBJECT(prop_window->check_count_all),"toggled",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
*/
	gtk_box_pack_start(GTK_BOX(hbox2),cadre,FALSE,FALSE,50);

	hbox2=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
	gtk_widget_show(hbox2);
	label=gtk_label_new("Refresh process list every");
	gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,5);
	gtk_widget_show(label);
	adj=gtk_adjustment_new(prop->refresh_clist,1.0,30.0,1,1,1);
	prop_window->spin_list=gtk_spin_button_new(GTK_ADJUSTMENT(adj),1,0);
	gtk_box_pack_start(GTK_BOX(hbox2),prop_window->spin_list,FALSE,FALSE,5);
	gtk_widget_show(prop_window->spin_list);
/*
	gtk_signal_connect_object(GTK_OBJECT(adj),"value_changed",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
	gtk_signal_connect_object(GTK_OBJECT(prop->spin_list),"changed",
							GTK_SIGNAL_FUNC(gnome_property_box_changed),
							GTK_OBJECT(prop->window));
*/
	label=gtk_label_new("seconds");
	gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,5);
	gtk_widget_show(label);

#ifndef APPLET
	/* Skins	*/
	vbox = file_prefs_notebook_append_page (GTK_NOTEBOOK (notebook),
                      "GProc Skins",
                      GTK_CTREE (ctree),
                      "Skins",
                      NULL,
                      &top_insert,
                      page_index);
    gtk_widget_show (vbox);
    page_index++;
	
	hbox2=gtk_hbox_new(FALSE,10);
	gtk_box_pack_start(GTK_BOX(vbox),hbox2,TRUE,TRUE,5);
	gtk_widget_show(hbox2);
	scrolled=gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled),GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_widget_show(scrolled);
	gtk_box_pack_start(GTK_BOX(hbox2),scrolled,TRUE,TRUE,0);
	skins_clist=gtk_clist_new_with_titles(2,skins_clist_titles);
	gtk_widget_show(skins_clist);
	gtk_signal_connect (GTK_OBJECT (skins_clist), "select_row",GTK_SIGNAL_FUNC(skin_selected), NULL);
    gtk_clist_set_shadow_type(GTK_CLIST(skins_clist), GTK_SHADOW_OUT);
    gtk_clist_column_titles_passive(GTK_CLIST(skins_clist));
    gtk_clist_set_column_auto_resize(GTK_CLIST(skins_clist),0,TRUE);
	gtk_container_add(GTK_CONTAINER(scrolled), skins_clist);
	prop_window->skin_path_tmp=strdup(prop->skin_path);
	scan_skins(skins_clist, GPROC_DIR "skins");
	scan_skins(skins_clist, home_skins_dir);

	hbox2=gtk_hbox_new(FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,5);
    gtk_widget_show(hbox2);
    label=gtk_label_new("Current Skin: ");
    gtk_box_pack_start(GTK_BOX(hbox2),label,FALSE,FALSE,5);
    gtk_widget_show(label);
    tframe=gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(tframe),GTK_SHADOW_ETCHED_OUT);
    gtk_widget_show(tframe);
    tbox=gtk_hbox_new(FALSE,5);
    gtk_widget_show(tbox);
    gtk_container_add(GTK_CONTAINER(tframe),tbox);
    prop_window->label_skin_name=gtk_label_new(prop->skin_name);
    gtk_box_pack_start(GTK_BOX(tbox),prop_window->label_skin_name,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(hbox2),tframe,FALSE,FALSE,5);
    gtk_widget_show(prop_window->label_skin_name);
	
#endif
	
	/*	About	*/
	vbox = file_prefs_notebook_append_page (GTK_NOTEBOOK (notebook),
                      "About GProc",
                      GTK_CTREE (ctree),
                      "About",
                      NULL,
                      &top_insert,
                      page_index);
	gtk_widget_show (vbox);
	page_index++;


    hbox2=gtk_hbox_new(TRUE,5);
    gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,0);
    gtk_widget_show(hbox2);
	icon=gtk_pixmap_new(pix,mask);
	gtk_box_pack_start(GTK_BOX(hbox2),icon,FALSE,FALSE,5);
	gtk_widget_show(icon);
	

	cadre=gtk_frame_new(NULL);
    gtk_widget_show(cadre);
	sprintf(buf, "\n\nGProc %s\n"
                "Copyright (c) 1999-2000 Jean Collonville (cjean@nexen.net)\n"
                "http://gproc.cjb.net\n"
				"http://cjean.cjb.net\n\n"
                "Released under the GNU Public License\n\n",
                VERSION);

	label=gtk_label_new(buf);
	gtk_widget_show(label);
	gtk_container_add(GTK_CONTAINER(cadre),label);
	gtk_box_pack_start(GTK_BOX(vbox),cadre,FALSE,FALSE,5);
	
	/*	buttons	*/
	hbox=gtk_hbox_new(TRUE,5);
	gtk_box_pack_start(GTK_BOX(prop_window->action_area),hbox, TRUE, TRUE, 5);
    gtk_widget_show(hbox);

	button=gtk_button_new_with_label("Ok");
	gtk_widget_set_usize(button,80,20);
	gtk_widget_show(button);
	gtk_signal_connect(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(apply_properties_cb),NULL);
	gtk_signal_connect(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(destroy_properties_cb),NULL);
	gtk_box_pack_start(GTK_BOX(hbox),button,FALSE,FALSE,5);

    button=gtk_button_new_with_label("Apply");
	gtk_widget_set_usize(button,80,20);
    gtk_widget_show(button);
    gtk_signal_connect(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(apply_properties_cb),NULL);
    gtk_box_pack_start(GTK_BOX(hbox),button,FALSE,FALSE,5);

    button=gtk_button_new_with_label("Cancel");
	gtk_widget_set_usize(button,80,20);
    gtk_widget_show(button);
    gtk_signal_connect(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(destroy_properties_cb),NULL);
    gtk_box_pack_start(GTK_BOX(hbox),button,FALSE,FALSE,5);

    button=gtk_button_new_with_label("Help");
	gtk_widget_set_usize(button,80,20);
    gtk_widget_show(button);
    gtk_signal_connect(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(show_help),NULL);
    gtk_box_pack_start(GTK_BOX(hbox),button,FALSE,FALSE,5);

	gtk_widget_show(prop_window->win);



}

#ifndef APPLET
/*	position de gproc	*/
void retreive_gproc_position(void)
{
	gchar buf[10];
	
	gproc_pos();
	sprintf(buf,"%d",prop->posX);
	gtk_entry_set_text(GTK_ENTRY(prop_window->label_posX),buf);
	sprintf(buf,"%d",prop->posY);
    gtk_entry_set_text(GTK_ENTRY(prop_window->label_posY),buf);

	
}



/*	selection d'une skin	*/
void skin_selected(GtkWidget *clist, gint row, gint column, GdkEventButton *bevent, gpointer data)
{
	prop_window->skin_path_tmp=gtk_clist_get_row_data(GTK_CLIST(clist), row);
	gtk_clist_get_text(GTK_CLIST(clist), row, 0, &(prop->skin_name));
}

/* liste des skins */
void scan_skins(GtkWidget *clist, gchar *skinsdir)
{
	DIR *dir;
    struct dirent *d;
	gchar *buf[2],*s,path[256];
	gint row;

	
	if((dir=opendir(skinsdir)) == NULL)
		return;
    
	while((d=readdir(dir)) != NULL)
    {
		
		sprintf(path,"%s/%s/",skinsdir,d->d_name);
		if(d->d_name[0]!='.' &&  d->d_ino>0 && opendir(path)) 
		{
			if(strcmp(path,prop->skin_path)==0)
				prop->skin_name=strdup(d->d_name);
			buf[0]=d->d_name;
			buf[1]=path;
			row=gtk_clist_append(GTK_CLIST(clist), buf);
			s=strdup(path);
			gtk_clist_set_row_data_full(GTK_CLIST(clist),row,s,(GtkDestroyNotify)g_free);
			
		}
	}

}



/*  label correspondant au choix d'orientation    */
void prop_orient_label(void)
{

    if(prop_window->temp_orient==ORIENT_VERT)
        gtk_label_set(GTK_LABEL(prop_window->label_button_orient),"Vertical");
    else
        gtk_label_set(GTK_LABEL(prop_window->label_button_orient),"Horizontal");
}

/*	horizontal ou vertical ?  */
gint prop_orient_choice(GtkWidget *widget, gpointer data)
{

    if(prop_window->temp_orient==ORIENT_HORIZ)
        prop_window->temp_orient=ORIENT_VERT;
    else
        prop_window->temp_orient=ORIENT_HORIZ;

    prop_orient_label();
    return 1;
}
#endif


/*  label correspondant au choix d'affichage    */
void prop_tree_label(void)
{
	
	if(prop_window->temp_tree_view==TRUE)
		gtk_label_set(GTK_LABEL(prop_window->label_button_tree),"Tree View mode");
	else
		gtk_label_set(GTK_LABEL(prop_window->label_button_tree),"List View mode");
}


/* treeview ou clist ?  */
gint prop_tree_choice(GtkWidget *widget, gpointer data)
{

	if(prop_window->temp_tree_view==TRUE)
		prop_window->temp_tree_view=FALSE;
	else
		prop_window->temp_tree_view=TRUE;

	prop_tree_label();
	return 1;
}


/*  on veut de l'aide ? */
void show_help(GtkWidget *widget, gpointer data)
{

	GtkWidget *box;
	GtkWidget *win;
	GtkWidget *window;
	GtkWidget *cadre;
	GtkWidget *icon;
	GtkWidget *label;
	GtkWidget *button;
	GdkPixmap *pix;
	GdkBitmap *mask;
	GtkWidget *check_help;
	gint scrX,scrY;

	

	scrX=gdk_screen_width();
	scrY=gdk_screen_height();
#ifdef APPLET
	win=app->applet;
#else
	win=app->window;
#endif
	
	window=gtk_dialog_new();
	gtk_widget_realize(window);
	gtk_window_set_policy(GTK_WINDOW(window),FALSE,FALSE,TRUE);
	gtk_widget_set_uposition(window,scrX/2-150,scrY/2-200);
	gtk_window_set_title(GTK_WINDOW(window), "GProc help");
	
	pix=gdk_pixmap_create_from_xpm(win->window,&mask,NULL, GPROC_DIR "icons/gproc-help.xpm");
	icon=gtk_pixmap_new(pix,mask);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),icon,FALSE,FALSE,5);
	gtk_widget_show(icon);

	
	box=gtk_hbox_new(FALSE,20);
	gtk_widget_show(box);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),box,FALSE,FALSE,0);
	cadre=gtk_frame_new(NULL);
	gtk_box_pack_start(GTK_BOX(box),cadre,FALSE,FALSE,10);
	gtk_widget_show(cadre);
	box=gtk_hbox_new(FALSE, 10);
	gtk_widget_show(box);
	gtk_container_add(GTK_CONTAINER(cadre), box);
	
	label=gtk_label_new("\n \
			Leftclick on the button displays the list of the running processes.\n\n \
			Rightclick on the button displays GProc menu: \
				  Configuration panel \
				  Run gtop \
				  Quit the program\n\n \
			To move GProc on your desktop use the left border (in horizontal mode)   \
			or the top border(in vertical mode). \
			RightClicking here displays the menu to.\n\n \
			RightClicking on the label allow you to play with it\n \
			");
	gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
	gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
	gtk_widget_show(label);
	
	check_help=gtk_check_button_new_with_label("Display this screen at startup");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_help),prop->show_help);
	gtk_signal_connect(GTK_OBJECT(check_help), "toggled", GTK_SIGNAL_FUNC(is_check_help),NULL);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),check_help,TRUE,FALSE,20);
	gtk_widget_show(check_help);
	
	button=gtk_button_new_with_label("Ok");
	gtk_widget_set_usize(button,80,20);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->action_area),button,FALSE,FALSE,5);
	gtk_signal_connect_object(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(window));
	gtk_widget_show(button);
	gtk_widget_show(window);
	
}

/* aide au demarrage ? */
void is_check_help(GtkWidget *widget, gpointer data)
{
	
	if(GTK_TOGGLE_BUTTON(widget)->active)
		prop->show_help=1;
	else
		prop->show_help=0;

}

/*  applique les proprietes */
void apply_properties_cb(GtkWidget *widget, gpointer data)
{
	gchar *text;
	gint old_refresh_label;
	gint old_refresh_list;
	struct passwd *pswd;
	
	prop->owner_name_filter_pressed = GTK_TOGGLE_BUTTON(prop_window->filter)->active;
	text=gtk_entry_get_text(GTK_ENTRY(prop_window->edit));
	prop->owner_name_filter_static = strdup(text);

	if (GTK_TOGGLE_BUTTON(prop_window->filter)->active)
		prop->owner_name_filter= prop->owner_name_filter_static;
	else
		prop->owner_name_filter="";

	if(GTK_TOGGLE_BUTTON(prop_window->check_close_popup_after_sig)->active)
		prop->close_popup_after_sig=TRUE;
	else
		prop->close_popup_after_sig=FALSE;
	
	if(GTK_TOGGLE_BUTTON(prop_window->check_short_proc_state)->active)
		prop->short_proc_state=TRUE;
	else
		prop->short_proc_state=FALSE;

	if(GTK_TOGGLE_BUTTON(prop_window->check_expand_tree)->active)
		prop->expand_tree=TRUE;
	else
		prop->expand_tree=FALSE;

	prop->tree_view=prop_window->temp_tree_view;
	prop->orient=prop_window->temp_orient;
	
	if(GTK_TOGGLE_BUTTON(prop_window->check_count_all)->active)
		prop->compt_all=TRUE;
	else
		prop->compt_all=FALSE;

	if(	strcmp(prop->owner_name_filter,"")==0)
		prop->owner_uid_filter=-1;
	else
	{
		if( (pswd=getpwnam(prop->owner_name_filter))==NULL)
			win_error("Invalid user! Please check the name...",ERROR);
		else
			prop->owner_uid_filter=pswd->pw_uid;
	}

	old_refresh_label=prop->refresh_label;
	prop->refresh_label=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(prop_window->spin_label));
	
	if(old_refresh_label!=prop->refresh_label)
	{
    	gtk_timeout_remove(timer_label);
#ifdef APPLET
		timer_label=gtk_timeout_add((prop->refresh_label)*1000,update_applet_label,NULL);
#else
		timer_label=gtk_timeout_add((prop->refresh_label)*1000,update_interface_label,NULL);
#endif
	}

	old_refresh_list=prop->refresh_clist;
	prop->refresh_clist=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(prop_window->spin_list));
	old_refresh_list=prop->refresh_ctree;
	prop->refresh_ctree=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(prop_window->spin_tree));
	
	if(prop->tree_view==FALSE)
	{
		if( (popup_open) && (old_refresh_list!=prop->refresh_clist))
		{
			gtk_timeout_remove(timer_list);
			timer_list=gtk_timeout_add((prop->refresh_list)*1000,update_proc_list,NULL);
		}
	}
	else
	{
    	if( (popup_open) && (old_refresh_list!=prop->refresh_ctree) )
        {
           	gtk_timeout_remove(timer_list);
			timer_list=gtk_timeout_add((prop->refresh_ctree)*1000,update_proc_list,NULL);
    	}
	}

	prop->popup_width=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(prop_window->spin_popup_width));
	prop->popup_height=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(prop_window->spin_popup_height));

#ifndef APPLET
	
	if(strcmp(prop->skin_path,prop_window->skin_path_tmp)!=0)
	{
		prop->skin_path=strdup(prop_window->skin_path_tmp);
		gtk_label_set_text(GTK_LABEL(prop_window->label_skin_name), prop->skin_name );
		redraw_gproc();
	}
	update_interface_label(NULL);
	change_gproc_orient();
#else
	update_applet_label(NULL);
#endif

	save_gproc_config();
}


/*  detruit la fenetre de proprietes    */
gint destroy_properties_cb(GtkWidget *widget, gpointer data)
{
	gtk_widget_destroy(prop_window->win);
	prop_window->win=NULL;
	g_free(prop_window->win);
	prop_window=NULL;
	return FALSE;
}



/*  affichage des Messages d'erreurs ou informations    */
void win_error(gchar *mesg, gint type)
{
	GtkWidget *win;
	GtkWidget *window;
	GtkWidget *icon;
	GtkWidget *hbox;
	GtkWidget *label;
	GtkWidget *button;
	GdkPixmap *pix;
	GdkBitmap *mask;
	gint scrX,scrY;
	gchar *icon_path;
	gint no_icon=FALSE;
	if(win_error_open==TRUE)
    	return;

	win_error_open=TRUE;

	
	scrX=gdk_screen_width();
	scrY=gdk_screen_height();
#ifdef APPLET
	win=app->applet;
#else
	win=app->window;
#endif
	
	window=gtk_dialog_new();
	gtk_widget_set_uposition(window,scrX/2-150,scrY/2-50);
	hbox=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),hbox,TRUE,TRUE,20);
	gtk_widget_show(hbox);
	
	switch(type)
	{
		case QUESTION:
			icon_path=strdup( GPROC_DIR "icons/gproc-question.xpm");
			break;
		case ERROR:
			 icon_path=strdup( GPROC_DIR "icons/gproc-error.xpm");
			break;
		case WARNING:
			icon_path=strdup( GPROC_DIR "icons/gproc-warning.xpm");
			break;
		case NOICON:
			default:
				no_icon=TRUE;
				break;
	}
	if(no_icon==FALSE)
	{
		pix=gdk_pixmap_create_from_xpm(win->window,&mask,NULL,icon_path);
		icon=gtk_pixmap_new(pix,mask);
		gtk_box_pack_start(GTK_BOX(hbox),icon,FALSE,FALSE,5);
		gtk_widget_show(icon);
		free(icon_path);

	}
	label=gtk_label_new(mesg);
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,5);
	gtk_widget_show(label);
	button=gtk_button_new_with_label("Ok");
	gtk_widget_set_usize(button,80,20);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->action_area),button,FALSE,FALSE,5);
	gtk_widget_show(button);
	gtk_widget_show(window);
	gtk_signal_connect(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(destroy_win_error),window);
	gtk_signal_connect(GTK_OBJECT(window),"unmap",GTK_SIGNAL_FUNC(destroy_win_error),window);
	
	
}

/*  fenetre de messages d'erreurs fermee    */
gint destroy_win_error(GtkWidget *widget, gpointer data)
{
	win_error_open=FALSE;
	gtk_widget_destroy(GTK_WIDGET(data));
	return TRUE;
}


#ifdef APPLET
/*  affichage de la fenetre a propos... */
void about_cb(AppletWidget *widget,gpointer data)
{

	GtkWidget *about;
	static const gchar *author[2]={"CJean <cjean@nexen.net>",NULL};

	if(about_open==TRUE)
		return;
    
	about=gnome_about_new("GProc Applet",VERSION,"(C) 1999 Nomad' Productions (GPL licence)",author,
							"GProc allows you to manage your processes with only a few mouse clicks. \
Please report bugs or suggestions to cjean@nexen.net \
							\"Je parle Anglais comme je veux :-)\"",
							"gproc-icon.png");

	gtk_signal_connect(GTK_OBJECT(about),"unmap",GTK_SIGNAL_FUNC(dest_about_cb),NULL);
	gtk_widget_show(about);
	about_open=TRUE;

	return;
}

/*  fermeture de la fenetre a propos... */
void dest_about_cb(GtkWidget *widget, gpointer data)
{
	about_open=FALSE;
	return;
}
#endif
