#include "gproc.h"

gchar *_gproc_column_name[] = {"Name", "PID", "Owner","Status"};
signaux sign_tab[NBSIGN]={
			{"SIGHUP",SIGHUP},
			{"SIGINT",SIGINT},
			{"SIGQUIT",SIGQUIT},
			{"SIGABRT",SIGABRT},
			{"SIGKILL",SIGKILL},
			{"SIGALRM",SIGALRM},
			{"SIGTERM",SIGTERM},
			{"SIGCHLD",SIGCHLD},
			{"SIGCONT",SIGCONT},
			{"SIGSTOP",SIGSTOP}
						};


						

/*	comptage du nombre de process	*/
gint count_proc(void)
{
	
    DIR *dir;
    struct dirent *d;
    gchar path[50];
    struct stat p_stat;
  	
    if(!LOCK_COMPT)
    {
        nbProc=0;
        if((dir=opendir("/proc")) == NULL)
        {
            g_error("Impossible d'ouvrir /proc\n");
            return -1;
        }
        while((d=readdir(dir)) != NULL)
        {
            sprintf(path,"/proc/%s/stat",d->d_name);
            if((atoi(d->d_name))==0) continue;

            lstat(path,&p_stat);
            if( (prop->owner_uid_filter==p_stat.st_uid) || (prop->tree_view==TRUE) || 
				(prop->compt_all==TRUE) || 	((gint)prop->owner_uid_filter==-1) )
                nbProc++;
        }
        closedir(dir);
    }
	
	return nbProc;

}





/*	update la liste des process	*/
gint update_proc_list(gpointer data)
{
	process *proc, *proc_tmp, *proc_new;
	GList *list_tmp=NULL;
	gint flag_new=FALSE;
	gint i,j;

		
	/* enleve les process disparus */
	for(i=0;i<g_list_length(proc_list);i++)
	{
		proc=g_list_nth_data(proc_list, i);
		if(kill(proc->pid,0)!=0)
		{
			if(errno==ESRCH)
			{	
				
				if(prop->tree_view==FALSE)
					update_clist(REMOVE,&proc);	
				else
					update_ctree(REMOVE,&proc);

				proc_list=g_list_remove(proc_list, proc);
			}
		}
	}


	/* ajout et modif de process */
	list_tmp=set_proc_list(list_tmp);
	
	for(i=0;i<g_list_length(list_tmp);i++)
	{
		flag_new=TRUE;
		proc_tmp=g_list_nth_data(list_tmp, i);
		
		for(j=0;j<g_list_length(proc_list);j++)
		{	
			proc=g_list_nth_data(proc_list, j);
			
			// pid egaux, on regarde juste si l'etat du process a change
			if( proc->pid==proc_tmp->pid )
			{
				flag_new=FALSE;
				
				if( strcmp(proc->status,proc_tmp->status)!=0 
							|| strcmp(proc->owner,proc_tmp->owner)!=0 
							|| proc->ppid!=proc_tmp->ppid )
				{
								
					free(proc->owner);
					free(proc->cppid);
					free(proc->status);
					proc->owner=strdup(proc_tmp->owner);
					proc->cppid=strdup(proc_tmp->cppid);
                   	proc->status=strdup(proc_tmp->status);
					proc->ppid=proc_tmp->ppid;
				
					if(prop->tree_view)
						update_ctree(UPDATE,&proc);
					else
						update_clist(UPDATE,&proc);
				}
			}
			
		}
		
		
		// ok ce process est nouveau, on le rajoute !
		if(flag_new==TRUE)
        {
			g_print("new: %s(%d)\n",proc_tmp->nom, proc_tmp->pid);
			proc_new=(process*)malloc(sizeof(process));
			proc_new->nom=strdup(proc_tmp->nom);
			proc_new->owner=strdup(proc_tmp->owner);
			proc_new->status=strdup(proc_tmp->status);
			proc_new->cpid=strdup(proc_tmp->cpid);
			proc_new->cppid=strdup(proc_tmp->cppid);
			proc_new->pid=proc_tmp->pid;
			proc_new->ppid=proc_tmp->ppid;
			proc_new->uid=proc_tmp->uid;
			
			proc_list=g_list_append(proc_list, proc_new);
		
			if(prop->tree_view==FALSE)
				update_clist(ADD,&proc_new);
			else
				update_ctree(ADD,&proc_new);
	
		}

	}
	
	g_list_foreach(list_tmp, free_proc_list, NULL);
	g_list_free(list_tmp);
	list_tmp=NULL;
	return 1;
}



/*	Remplissage d'une structure de process	*/
process *fill_proc(gchar *file_name)
{

	FILE *file;
	gchar path[256];
	gchar buf[256];
	gchar *s, *arg;
	struct stat p_stat;
	struct passwd *p_passwd;
	process *proc;
	proc=(process*)malloc(sizeof(process));

	sprintf(path, "/proc/%s/status", file_name);
	
	lstat(path, &p_stat);
	p_passwd=getpwuid(p_stat.st_uid);

		
	if( (file=fopen(path, "r"))!=NULL )
	{
		while( fgets(buf, sizeof(buf), file) )
		{
			s=strtok(buf," :=\n");
			if ( s==NULL || *s=='\n' || *s=='\0' )
				continue;
			
			if(strcmp(s,"Name")==0)
			{
				arg=strtok(NULL,"\n");
				while( *arg=='\t' )	arg++;
				if(strcmp(arg,"\n")==0)
					proc->nom=strdup("null");
				else
					proc->nom=strdup(arg);
			}
			if(strcmp(s,"State")==0)
			{
				arg=strtok(NULL,"\n");
				while( *arg=='\t' )	arg++;
				if(strcmp(arg,"\n")==0)
					proc->status=strdup("null");
				else
					proc->status=strdup(arg);
			}
			if(strcmp(s,"Pid")==0)
			{
				arg=strtok(NULL,"\n");
				while( *arg=='\t' )	arg++;
				if(strcmp(arg,"\n")==0)
				{
					proc->pid=0;
					proc->cpid=strdup("0");
				}
				else
				{				
					proc->pid=atoi(arg);
					proc->cpid=strdup(arg);
				}
			}
			if(strcmp(s,"PPid")==0)
			{
				arg=strtok(NULL,"\n");
				while( *arg=='\t' )	arg++;
				if(strcmp(arg,"\n")==0)
				{
					proc->ppid=0;
					proc->cppid=strdup("0");
				}
				else
				{				
					proc->ppid=atoi(arg);
					proc->cppid=strdup(arg);
				}
			}
		}
		
		proc->owner=strdup(p_passwd->pw_name);
		proc->uid=p_passwd->pw_uid;
		
	}
	else
	{
		g_print("Unable to open the file %s!\n",file_name);
		return NULL;
	}
	fclose(file);
	return proc;
}




/* liberation memoire d'un element de la liste de process  */
void free_proc_list(gpointer data, gpointer u_data)
{
	free(data);
}


/*	construct liste des process	*/
GList *set_proc_list(GList *list)
{
	DIR *dir;
	struct dirent *d;
	struct stat p_stat;
	struct passwd *p_passwd;
	gchar path[256];
	process *proc;

	
	// liberation memoire de la liste si necessaire
	g_list_foreach(list, free_proc_list, NULL);
	g_list_free(list);
	list=NULL;
	
	if( (dir=opendir("/proc"))==NULL )
	{
		g_error("Error while trying to open /proc\n");
		return NULL;
	}
	while( (d=readdir(dir))!=NULL )
	{
		if( atoi(d->d_name)==0 )
			continue;
		sprintf(path, "/proc/%s/status", d->d_name);
		lstat(path, &p_stat);
		p_passwd=getpwuid(p_stat.st_uid);
		if( (prop->owner_uid_filter==-1) || (prop->owner_uid_filter==p_passwd->pw_uid) || (prop->tree_view==TRUE) )
		{
			if( (proc=fill_proc(d->d_name))!=NULL)
			{	
				list=g_list_append(list, proc);
				
			}
		}
	} 	

	closedir(dir);
	
	return list;
}




/*construction de la clist	*/
void construct_clist(GList *list)
{
	process *proc;
	gint row;
	gint i;
	gint length=GPROC_NUM_COLUMNS;
	gchar *pcs[length];
	GdkPixmap *pix;
	GdkBitmap *mask;
	GtkWidget *win;

#ifdef APPLET
	win=app->applet;
#else
	win=app->window;
#endif
	pix=gdk_pixmap_create_from_xpm(win->window,&mask,NULL, GPROC_DIR "icons/asc.xpm");
    sort_asc=gtk_pixmap_new(pix,mask);
	gtk_widget_ref(sort_asc);
	pix=gdk_pixmap_create_from_xpm(win->window,&mask,NULL, GPROC_DIR "icons/dsc.xpm");
	sort_dsc=gtk_pixmap_new(pix,mask);
	gtk_widget_ref(sort_dsc);

	process_clist = gtk_clist_new(GPROC_NUM_COLUMNS);
	gtk_clist_column_titles_show (GTK_CLIST(process_clist));

	for (i=0; i<length; i++) 
	{
		columns[i].label = gtk_label_new (_gproc_column_name[i]);
		columns[i].hbox = gtk_hbox_new (FALSE, 0);

		gtk_widget_show (columns[i].label);
		gtk_widget_show (columns[i].hbox);
		gtk_clist_set_column_auto_resize(GTK_CLIST(process_clist),i,TRUE);
		gtk_box_pack_start_defaults (GTK_BOX(columns[i].hbox), columns[i].label);
		gtk_clist_set_column_widget (GTK_CLIST(process_clist), i, columns[i].hbox);
	}

	gtk_widget_activate(GTK_WIDGET(process_clist));

	gtk_signal_connect(GTK_OBJECT(process_clist),"click-column",
						GTK_SIGNAL_FUNC(column_sig_handler),NULL);
	gtk_signal_connect(GTK_OBJECT(process_clist),"select_row",
						GTK_SIGNAL_FUNC(select_proc_clist),NULL);
	gtk_signal_connect (GTK_OBJECT(process_clist), "button-release-event",
						GTK_SIGNAL_FUNC(click_clist), NULL);
	gtk_signal_connect(GTK_OBJECT(process_clist),"key_press_event",
						GTK_SIGNAL_FUNC(clist_key_event), NULL);

	
	gtk_clist_set_shadow_type (GTK_CLIST(process_clist), GTK_SHADOW_IN);
	gtk_widget_activate(GTK_WIDGET(process_clist));
	gtk_widget_show(process_clist);


	for(i=0;i<g_list_length(list);i++)
	{
		proc=g_list_nth_data(list, i);
		pcs[0]=proc->nom;
		pcs[1]=proc->cpid;
		pcs[2]=proc->owner;
		pcs[3]=proc->status;
	
		row=gtk_clist_append(GTK_CLIST(process_clist),pcs);
		gtk_clist_set_row_data(GTK_CLIST(process_clist), row, proc);

	}


}




/*  on update la clist */
gint update_clist(gint action, process **proco)
{
	process *proc=*proco;
	gint index;
	gint row;
	gint length=GPROC_NUM_COLUMNS;
	gchar *pcs[length];

	gtk_clist_freeze(GTK_CLIST(process_clist));

	switch(action)
	{
		case(ADD):
				pcs[0]=proc->nom;
				pcs[1]=proc->cpid;
				pcs[2]=proc->owner;
				pcs[3]=proc->status;
				row=gtk_clist_append(GTK_CLIST(process_clist),pcs);
				gtk_clist_set_row_data(GTK_CLIST(process_clist), row, proc);
				break;

		case(REMOVE):
				index=gtk_clist_find_row_from_data(GTK_CLIST(process_clist),proc);
				gtk_clist_remove(GTK_CLIST(process_clist),index);
				break;
		
		case(UPDATE):
				index=gtk_clist_find_row_from_data(GTK_CLIST(process_clist),proc);
				gtk_clist_set_text(GTK_CLIST(process_clist),index,2,proc->owner);
				gtk_clist_set_text(GTK_CLIST(process_clist),index,3,proc->status);
	}

	gtk_clist_set_sort_type(GTK_CLIST(process_clist), (GtkSortType)prop->sort_type);
	gtk_clist_sort(GTK_CLIST(process_clist));
	gtk_clist_thaw(GTK_CLIST(process_clist));

	return TRUE;
}








/* Construction du treeview	*/
void construct_tree(GList *list)
{

	process *proc,*tmp;
	gint length=GPROC_NUM_COLUMNS;
	gint i,j;
	gchar *text_node[length];
		
	process_ctree=gtk_ctree_new_with_titles(length,0,_gproc_column_name);
	for(i=0;i<length;i++)
	{
		gtk_clist_set_column_auto_resize(GTK_CLIST(process_ctree),i, TRUE);
	}
	
	gtk_ctree_set_line_style(GTK_CTREE(process_ctree), GTK_CTREE_LINES_DOTTED);
	gtk_ctree_set_indent(GTK_CTREE(process_ctree),10);
	gtk_clist_column_titles_passive(GTK_CLIST(process_ctree));


	proc=(process*)g_list_nth_data(list, 0);

	text_node[0]=proc->nom;
	text_node[1]=proc->cpid;
    text_node[2]=proc->owner;
	text_node[3]=proc->status;

	proc->node_parent=NULL;
	proc->node=gtk_ctree_insert_node(GTK_CTREE(process_ctree),NULL,NULL,
								text_node,length,NULL,NULL,NULL,NULL,
								FALSE, FALSE);
	gtk_ctree_node_set_row_data(GTK_CTREE(process_ctree),proc->node,proc);


	for(i=0;i<g_list_length(list);i++)
	{
		 	
		proc=g_list_nth_data(list, i);
 	
		for(j=i;j<g_list_length(list);j++)
		{	
			tmp=g_list_nth_data(list, j);			
			if(tmp->ppid==proc->pid)
			{ 	

				text_node[0]=tmp->nom;
			    text_node[1]=tmp->cpid;
				text_node[2]=tmp->owner;
				text_node[3]=tmp->status;
				
				tmp->node_parent=proc->node;
				tmp->node=gtk_ctree_insert_node(GTK_CTREE(process_ctree),proc->node,NULL,
											text_node,length,NULL,NULL,NULL,NULL,
											FALSE,FALSE);
				gtk_ctree_node_set_row_data(GTK_CTREE(process_ctree),tmp->node,tmp);
			}
		}
	}

	gtk_widget_show(process_ctree);
		
	gtk_signal_connect(GTK_OBJECT(process_ctree),"tree-select-row",GTK_SIGNAL_FUNC(select_proc_tree),NULL);
	gtk_signal_connect(GTK_OBJECT(process_ctree),"button-release-event",GTK_SIGNAL_FUNC(click_tree),NULL);	
	
	proc=g_list_nth_data(list, 0);

	if(prop->expand_tree==TRUE)
		gtk_ctree_expand_recursive(GTK_CTREE(process_ctree),proc->node);
	else
		gtk_ctree_expand(GTK_CTREE(process_ctree),proc->node);
		
 	

}



/*	on update le ctree	*/
gint update_ctree(gint action, process **proco)
{
	process *proc=*proco;
	process *proc_tmp;
    gint length=GPROC_NUM_COLUMNS;
    gchar *pcs[length];
	gint i;

	proc_tmp=g_list_nth_data(proc_list, 0);
    
	switch(action)
    {
        case(ADD):
				pcs[0]=proc->nom;
				pcs[1]=proc->cpid;
                pcs[2]=proc->owner;
				pcs[3]=proc->status;
				
				for(i=0;i<g_list_length(proc_list);i++)
		        {
					proc_tmp=g_list_nth_data(proc_list, i);
        	    	if(proc->ppid==proc_tmp->pid)
            		{
						proc->node_parent=proc_tmp->node;
						proc->node=gtk_ctree_insert_node(GTK_CTREE(process_ctree),proc_tmp->node,NULL,
														pcs,length,NULL,NULL,NULL,NULL,
														FALSE,FALSE
														);
		                gtk_ctree_node_set_row_data(GTK_CTREE(process_ctree),proc->node,proc);
						break;			
					}
				}
							
                break;
				
        case(REMOVE):
				if(gtk_ctree_find(GTK_CTREE(process_ctree),NULL,proc->node))
				{
					update_ctree(MOVE_AFTER_TO_BEFORE,&proc);
					gtk_ctree_remove_node(GTK_CTREE(process_ctree),proc->node);
				}
				
				break;
				
		case(UPDATE):
				gtk_ctree_node_set_text(GTK_CTREE(process_ctree),proc->node,2,proc->owner);
				gtk_ctree_node_set_text(GTK_CTREE(process_ctree),proc->node,3,proc->status);
				break;
				
		case(MOVE_AFTER_TO_BEFORE):
				for(i=0;i<g_list_length(proc_list);i++)
				{
					proc_tmp=g_list_nth_data(proc_list, i);
					if(proc_tmp->node_parent==proc->node)
					{
						gtk_ctree_move(GTK_CTREE(process_ctree),proc_tmp->node,proc->node_parent,NULL);
						proc_tmp->node_parent=proc->node_parent;
					}
			
				};
				break;
    }

	if( (prop->expand_tree==TRUE) && (action==ADD) )
		gtk_ctree_expand_recursive(GTK_CTREE(process_ctree),proc_tmp->node);


	
	return TRUE;
}







/*	fermeture de la fenetre popup contenant la liste des process	*/
gint close_pop(GtkWidget *widget,gpointer data)
{
	gtk_timeout_remove(timer_list);
	if(prop->tree_view==TRUE)
    {
        gtk_widget_destroy(GTK_WIDGET(process_ctree));
   		process_ctree=NULL;
	}
    else
    {
        gtk_widget_destroy(GTK_WIDGET(process_clist));
    	process_clist=NULL;
	}

	g_list_foreach(proc_list, free_proc_list, NULL);
	g_list_free(proc_list);
	proc_list=NULL;
	gdk_pointer_ungrab(GDK_CURRENT_TIME);
	gtk_grab_remove(GTK_WIDGET(popup_window));
	gtk_widget_destroy(GTK_WIDGET(popup_window));
	
	popup_open=FALSE;	
#ifndef APPLET
	redraw_interface_button(popup_open);
#endif
	return TRUE;

}





/*	Envoi du signal	*/
void cb_send_signal(GtkWidget *widget, gpointer data)
{

	if(kill(proc_select->pid,(gint)data)!=0)
	{
		if(errno==EINVAL)
			win_error("This signal does not exist !",WARNING);
		if(errno==ESRCH)
		{
			win_error("This process does not exist !",WARNING);
			update_proc_list(NULL);
		}
		if(errno==EPERM)
			win_error("You are not allowed to send signal to this process !",WARNING);			
		close_pop(popup_window,NULL);
	}	
	else
	{
		if(prop->close_popup_after_sig==TRUE)
			close_pop(popup_window,NULL);
		else
			update_proc_list(NULL);
	}	
}







/*	selection d'un process puis du signal a lui envoyer	dans clist	*/
gint select_proc_clist(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data)
{
	proc_select=gtk_clist_get_row_data(GTK_CLIST(process_clist),row);
	gtk_container_set_focus_child(GTK_CONTAINER(scroll_win),process_clist);

	return TRUE;
}





/*	un click droit dans clist fait apparaitre popup pour row selected	*/
gint click_clist(GtkWidget *widget, GdkEventButton *event, gpointer data)
{
	
    if( (event->button==3) && (proc_select) )
    {
        create_popup_sign(event);
        return TRUE;
    }
    
	return FALSE;

}




/*  selection d'un process puis du signal a lui envoyer dans le tree	*/
gint select_proc_tree(GtkCTree *tree, GList *node, gint column, gpointer data)
{
	proc_select=gtk_ctree_node_get_row_data(GTK_CTREE(process_ctree),GTK_CTREE_NODE(node));	
	return TRUE;
}




/*	click sur le CTree	*/
gint click_tree(GtkWidget *widget, GdkEventButton *event, gpointer data)
{
	
	if( (event->button==3) && (proc_select) )
    	create_popup_sign(event);
    
	return TRUE;
}
	




/* creation du menu de choix des signaux	*/
void create_popup_sign(GdkEventButton *event)
{
	GtkWidget *popup;
	GtkWidget *item;
//	GtkWidget *subpopup;
	gint i;
	
/*	if(kill(proc_select->pid,0)!=0)
		if(errno==EPERM)
			return;
*/	
	popup=gtk_menu_new();
/*	
	item=gtk_menu_item_new_with_label("More");
	gtk_widget_show(item);
	gtk_menu_append(GTK_MENU(popup),item);

	
	subpopup=gtk_menu_new();
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(item),subpopup);

	item=gtk_menu_item_new_with_label("Renice");
	gtk_widget_show(item);
	gtk_menu_append(GTK_MENU(subpopup),item);
	gtk_signal_connect(GTK_OBJECT(item),"activate",GTK_SIGNAL_FUNC(cb_renice),NULL);
*/
	for(i=0;i<NBSIGN;i++)
    {
		item=gtk_menu_item_new_with_label(sign_tab[i].name);
	    gtk_widget_show(item);
   	 	gtk_menu_append(GTK_MENU(popup),item);
    	gtk_signal_connect(GTK_OBJECT(item),"activate",GTK_SIGNAL_FUNC(cb_send_signal),(gpointer)sign_tab[i].val);
    }


	gtk_menu_popup(GTK_MENU(popup),NULL,NULL,NULL,NULL,event->button,event->time);
}



/*	renice d'un process	*/
void cb_renice(GtkWidget *widget, gpointer data)
{
	GtkWidget *window;
	GtkWidget *box;
	GtkWidget *label;
	GtkWidget *cadre;

	
	window=gtk_dialog_new();
	gtk_widget_realize(window);
	gtk_window_set_policy(GTK_WINDOW(window),FALSE,FALSE,TRUE);
	gtk_window_set_title(GTK_WINDOW(window), "Renice");
	
	box=gtk_hbox_new(FALSE,20);
	gtk_widget_show(box);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),box,FALSE,FALSE,10);
	
	cadre=gtk_frame_new(NULL);
	gtk_widget_show(cadre);
	gtk_box_pack_start(GTK_BOX(box),cadre,FALSE,FALSE,10);
	
	
	label=gtk_label_new("SOME PROCESS DETAILS");
	gtk_widget_show(label);
	gtk_container_add(GTK_CONTAINER(cadre), label);

	gtk_widget_show(window);
	//g_print("Renice process num : %d\n",proc_select->pid);
}



/*  en cas de click sur la fenetre de scroll    */
gint scroll_click(GtkWidget *widget, gpointer data)
{
	return TRUE;
}




/*	click sur le bouton principal	*/
gint main_btn_clicked(GtkWidget *widget, GdkEventButton *event, gpointer data)
{

	if(event->button==1)
	{
#ifndef APPLET
		redraw_interface_button(!popup_open);
#endif
		create_popup(NULL);
	}

#ifndef APPLET
	if(event->button==3)
		make_gproc_menu(event);
#endif
    return TRUE;
}





/*	creation de la fenetre popup	*/
void create_popup(void *data)
{
	
	gint scrX,scrY,diff;	
	GtkWidget *frame_main;
	GtkWidget *vbox;
#ifndef APPLET
	gint appW,appH;
#endif
	
	if(popup_open==FALSE)
	{
		popup_open=TRUE;
		LOCK_COMPT=TRUE;
		proc_select=NULL;
		
		
		popup_window=gtk_window_new(GTK_WINDOW_POPUP);
		gtk_widget_realize(popup_window);
		scrX=gdk_screen_width();
        scrY=gdk_screen_height();

#ifdef APPLET
		gdk_window_get_pointer(NULL,&posX,&posY,NULL);
		if(posX+prop->popup_width >= scrX)
            posX-=prop->popup_width+10;
        else
            posX=posX+10;

        if((diff=posY-prop->popup_height) <= 0)
        {
            if(scrY-prop->popup_height>posY)
                posY+=10;
            else
                posY=scrY-prop->popup_height-10;
        }

        else
            posY-=prop->popup_height+10;

#else
		gdk_window_get_deskrelative_origin(app->window->window,&posX, &posY);
		
	
		appW=(prop->orient==ORIENT_VERT) ? app->Vmwin_w : app->Hmwin_w;
		appH=(prop->orient==ORIENT_VERT) ? app->Vmwin_h : app->Hmwin_h;
		
		
		if(posX+prop->popup_width >= scrX)
            posX-=prop->popup_width-appW;
        
		if((diff=posY-prop->popup_height) <= 0)
        {
            if(scrY-prop->popup_height>posY)
                posY+=appH;
			else
			{
				if(posX+appW+prop->popup_width<scrX)
					posX+=appW;
				else 
				{
					if(posX+prop->popup_width>scrX)
						posX-=prop->popup_width;
					else
						posX-=appW;
				}
				
                posY=scrY-prop->popup_height-10;
			}
        }

        else
			posY-=prop->popup_height;
		
		if(posX<0)
			posX=0;
		if(posY<0)
			posY=0;
#endif
		
		gtk_widget_set_uposition(popup_window,posX,posY);
		gtk_widget_set_usize(GTK_WIDGET(popup_window),prop->popup_width,prop->popup_height);
		scroll_win=create_scroll_win(popup_window);

		gtk_signal_connect(GTK_OBJECT(popup_window),"button_press_event"
                            ,GTK_SIGNAL_FUNC(close_pop),NULL);

		vbox=gtk_vbox_new(FALSE,1);
     
		frame_main=gtk_frame_new(NULL);
        gtk_frame_set_shadow_type(GTK_FRAME(frame_main),GTK_SHADOW_OUT);
        
		
		gtk_box_pack_start(GTK_BOX(vbox),scroll_win,TRUE,TRUE,0);
		gtk_container_add(GTK_CONTAINER(frame_main),vbox);
		gtk_container_add(GTK_CONTAINER(popup_window),frame_main);
		gtk_widget_show(frame_main);
		gtk_widget_show(vbox);

		gtk_signal_connect(GTK_OBJECT(vbox),"button_press_event",GTK_SIGNAL_FUNC(scroll_click),NULL);

#ifdef APPLET	
		gdk_pointer_grab(popup_window->window,TRUE,
					     GDK_BUTTON_PRESS_MASK
            	        | GDK_BUTTON_RELEASE_MASK
                	    | GDK_ENTER_NOTIFY_MASK
                    	| GDK_LEAVE_NOTIFY_MASK
	                    | GDK_POINTER_MOTION_MASK,
    	                NULL,NULL,GDK_CURRENT_TIME);
                    
	    gtk_grab_add(popup_window);
#endif
		LOCK_COMPT=FALSE;
		
		gtk_widget_show(popup_window);

		if(prop->tree_view)
			timer_list=gtk_timeout_add((prop->refresh_ctree)*1000,update_proc_list,NULL);
		else
			timer_list=gtk_timeout_add((prop->refresh_clist)*1000,update_proc_list,NULL);

		
	}
	else
		close_pop(popup_window,NULL);
}



/* 	preparation du scroll et de la clist/ctree	*/
GtkWidget* create_scroll_win(GtkWidget *widget)
{
	GtkWidget *scrolled_window=NULL;
		
	scrolled_window=gtk_scrolled_window_new(NULL,NULL);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
    gtk_container_set_border_width(GTK_CONTAINER(scrolled_window),0);

	gtk_signal_connect(GTK_OBJECT(scrolled_window),"button_press_event",GTK_SIGNAL_FUNC(scroll_click),NULL);
	gtk_widget_show(scrolled_window);

//	set_proc_list(&proc_first);
	proc_list=set_proc_list(proc_list);
	if(prop->tree_view==FALSE)
	{
		construct_clist(proc_list);
		column_sig_handler(GTK_CLIST(process_clist), -1, NULL);
		gtk_container_add(GTK_CONTAINER(scrolled_window),process_clist);
	}
	else
	{
		construct_tree(proc_list);
		gtk_container_add(GTK_CONTAINER(scrolled_window),process_ctree);
	}

	return scrolled_window;
}


/* Receive callback from column widgets */
void column_sig_handler(GtkCList *clist, gint column, gpointer user_data) 
{
	GtkWidget *arrow;

	if(column != -1) 
	{
		arrow = (prop->sort_type == 1) ? sort_asc : sort_dsc;
		gtk_widget_hide(arrow);
		gtk_widget_unrealize(arrow);
		gtk_container_remove(GTK_CONTAINER(columns[prop->last_clicked_column].hbox),arrow);
		gtk_widget_show(columns[prop->last_clicked_column].hbox);
	
		if(prop->last_clicked_column == column) 
			prop->sort_type = !prop->sort_type;
		else 
			prop->sort_type = 0;
	}
	else 
		column = prop->last_clicked_column;
	
	/*
		Utliser qsort() et recuperer l'etat de la clist avec :
	   
     GTK_CLIST(process_clist)->vadjustment->value = value;
     GTK_CLIST(process_clist)->voffset = value;
     GTK_CLIST(process_clist)->hadjustment->value = value;
     GTK_CLIST(process_clist)->hoffset = value;
*/

	gtk_clist_set_sort_type(GTK_CLIST(clist), (GtkSortType)prop->sort_type);
	gtk_clist_set_sort_column(GTK_CLIST(clist), (gint)column);
	gtk_clist_sort(GTK_CLIST(clist));
	
	arrow = (prop->sort_type == 1) ? sort_asc : sort_dsc;
	gtk_box_pack_start(GTK_BOX(columns[column].hbox),arrow, FALSE, FALSE, 2);
	gtk_widget_show(arrow);
	
	prop->last_clicked_column = column;
}
			





/*	Called for each key pressed on the clist	*/
gboolean clist_key_event(GtkWidget *widget,GdkEventKey *event,gpointer user_data)
{

	gchar keys_pressed[30];
	long last_call_time = 0;
	gint index, i;
	process *proc;

	g_print("click");
  
	if(((long)time(NULL) - last_call_time) > 2) 
	    strcpy(keys_pressed, "");
  
	strcat(keys_pressed, event->string);

	if(prop->tree_view)
	{
		gdk_beep();
		return FALSE;
	}

	
	for(i=0;i<g_list_length(proc_list);i++)
	{
		proc=g_list_nth_data(proc_list, i);
		if(strncmp(&keys_pressed[0], proc->nom, strlen(keys_pressed)) == 0) 
		{
			index = gtk_clist_find_row_from_data(GTK_CLIST(process_clist), proc);
			if(index) 
				gtk_clist_select_row(GTK_CLIST(process_clist),index,1);
    	}
	}

	index = gtk_clist_find_row_from_data(GTK_CLIST(process_clist),&keys_pressed);
	
	if(index)
		gtk_clist_select_row(GTK_CLIST(process_clist),index,0);

	last_call_time = (long)time(NULL);
	
	return TRUE;
}
  





/*	lancement de gtop	*/
gint start_gtop(gpointer data)
{
    system("gtop &");
	return TRUE;
}








/*	MAIN ! MAIN ! MAIN !	*/ 
gint main(int argc,char **argv)
{
	prop_window=NULL;
	popup_open=FALSE;
	win_error_open=FALSE;
	LOCK_COMPT=FALSE;

#ifdef APPLET
	pattr=NULL;
	about_open=FALSE;
#endif
	proc_list=NULL;
	app=g_new(AppletWid,1);
	prop=g_new(properties,1);
	nbProc=0;
	read_gproc_config(); 

#ifdef APPLET
	
	applet_widget_init("gproc_applet",VERSION, argc, argv, NULL, 0, NULL);
	app->applet=applet_widget_new("gproc_applet");
	
	if(!app->applet)
		g_error("Applet creation failure...\n");
	gtk_widget_realize(app->applet);

	create_gproc_applet();
	update_applet_label(NULL);
	gtk_signal_connect(GTK_OBJECT(app->applet),"change_orient",
						GTK_SIGNAL_FUNC(change_orient),NULL);

#ifdef CVS_VERSION
	gtk_signal_connect(GTK_OBJECT(app->applet),"change_pixel_size",
                        GTK_SIGNAL_FUNC(change_size),NULL);
#endif

	timer_label=gtk_timeout_add((prop->refresh_label)*1000,update_applet_label,NULL);
	gtk_signal_connect (GTK_OBJECT(app->applet), "destroy",GTK_SIGNAL_FUNC (save_gproc_config), NULL);

	gtk_widget_show(app->applet);

	applet_widget_gtk_main();

#else
	gtk_init(&argc,&argv);
	create_gproc_interface();
	update_interface_label(NULL);
	timer_label=gtk_timeout_add((prop->refresh_label)*1000,update_interface_label,NULL);
	if(prop->show_help==1)
		show_help(NULL,NULL);
	gtk_main();
#endif

	
	 return 0;

}




