#include <errno.h>
#include <signal.h>
#include <pwd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <dirent.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>


#define VERSION					"0.6.0"
#define NBSIGN					10
#define QUESTION				1
#define ERROR					2
#define WARNING					3
#define NOICON					4
#define REMOVE					0
#define ADD						1
#define UPDATE					3
#define MOVE_AFTER_TO_BEFORE	4
#define GPROC_NUM_COLUMNS		4 
#define PROC_NOM				101
#define PROC_STATUS				102
#define PROC_OWNER				103
#define PROC_PID				104
#define ORIENT_VERT				2	
#define ORIENT_HORIZ			1
#define GPROC_DIR				"/usr/local/gproc/"
#define HOME_SKINS_DIR			"/.gproc/skins"

typedef struct proc 
{
	gchar *nom;
	gchar *status;
	gchar *owner;
	gchar *cpid;
	gchar *cppid;
	pid_t pid;
	pid_t ppid;
	uid_t uid;
	GtkCTreeNode *node;
	GtkCTreeNode *node_parent;
}process;


typedef struct 
{
	gchar *name;
	gint val;
}signaux;




#ifndef APPLET
typedef struct
{
	GtkWidget *window, *vmain, *hmain;
	GtkWidget *hdrawbutton, *vdrawbutton,*hdrawlabel, *vdrawlabel;
	GdkPixmap *hbg, *vbg, *vbgpix, *hbgpix;
	GdkGC *gcwin, *gclabel, *gclabelbis;
	GdkPixmap *hlabelbg, *vlabelbg, *vlabelpix,*hlabelpix;
	GdkPixmap *hbuttonOnpix,*vbuttonOnpix,*hbuttonOffpix,*vbuttonOffpix;
	GdkBitmap *Hmwin_mask,*Vmwin_mask;
	GdkColor font_color,font_colorbis;
	GdkFont *font;
	gint Hmwin_w, Hmwin_h;
	gint Hbutton_w, Hbutton_h;
	gint Hlabel_w, Hlabel_h;
	gint Vmwin_w, Vmwin_h;
	gint Vbutton_w, Vbutton_h;
	gint Vlabel_w, Vlabel_h;
	gint Htext_x, Htext_y;
	gint Vtext_x, Vtext_y;
	gint Hsep1, Hsep2, Hsep3;
	gint Vsep1, Vsep2, Vsep3;
	gchar *font_string;
	gchar *font_color_str;
	gchar *font_shadow_str;
} AppletWid;
#endif




typedef struct 
{
	gint posX, posY;
	gint orient;
	gint compt_all;
	gint tree_view;
	gint expand_tree;
	gint refresh_label;
	gint refresh_clist;
	gint refresh_ctree;
	gint refresh_list;
	gint popup_height,popup_width;
	gint owner_name_filter_pressed;
	gchar *owner_name_filter_static;
	gchar *owner_name_filter;
	gchar *skin_path;
	gchar *skin_name;
	uid_t owner_uid_filter;
	gint sort_type;
	gint last_clicked_column;
	gint close_popup_after_sig;	 
	gint show_help;
	gint short_proc_state;
}properties;


typedef struct 
{
	GtkWidget *win;
	GtkWidget *vbox;
	GtkWidget *action_area;
	GtkWidget *filter;
	GtkWidget *edit;
	GtkWidget *check_close_popup_after_sig;
	GtkWidget *check_count_all;
	GtkWidget *check_short_proc_state;
	GtkWidget *check_expand_tree;
	GtkWidget *button_tree;
	GtkWidget *button_orient;
	GtkWidget *label_button_tree;
	GtkWidget *label_button_orient;
	GtkWidget *spin_label;
	GtkWidget *spin_list;
	GtkWidget *spin_tree;
	GtkWidget *spin_popup_width;
	GtkWidget *spin_popup_height;
	GtkWidget *edit_theme;
	GtkWidget *label_posX,*label_posY;
	GtkWidget *label_skin_name;
	gchar *skin_path_tmp;
	gint temp_orient;
	gint temp_tree_view;

}properties_window;



typedef struct 
{
	GtkWidget *label;
	GtkWidget *hbox;
} gproc_column;





																																				 
		
#ifndef APPLET
	gint x_press,y_press;
#endif
AppletWid *app;
properties *prop;
properties_window *prop_window;
gproc_column columns[GPROC_NUM_COLUMNS];
GList *proc_list;
process *proc_select;
gint posX,posY;
gint timer_label;
gint timer_list;
gint nbProc;
gint popup_open;
gint win_error_open;
gint LOCK_COMPT;
GtkWidget *sort_asc;
GtkWidget *sort_dsc;
GtkWidget *process_clist;
GtkWidget *process_ctree;
GtkWidget *popup_window;
GtkWidget *scroll_win;


process *fill_proc(gchar *file_name);
GtkWidget* create_scroll_win(GtkWidget *widget);
void free_proc_list(gpointer data, gpointer u_data);
GList *set_proc_list(GList *list);
void create_popup(void *data);
void cb_send_signal(GtkWidget *widget, gpointer data);
void cb_renice(GtkWidget *widget, gpointer data);
void win_error(gchar *mesg,gint type);
void properties_cb(void *data);
void apply_properties_cb(GtkWidget *widget, gpointer data);
void show_help(GtkWidget *widget, gpointer data);
void construct_clist(GList *list);
void construct_tree(GList *list);
void create_popup_sign(GdkEventButton *event);
void prop_tree_label(void);
void column_sig_handler(GtkCList *clist, gint column, gpointer user_data);
gint start_gtop(gpointer data);
void free_proc_struct(process **proco);
gboolean clist_key_event(GtkWidget *widget,GdkEventKey *event,gpointer user_data);
gint update_clist(gint action, process **proco);
gint update_ctree(gint action, process **proco);
gint update_proc_list(gpointer data);
gint count_proc(void);
gint destroy_properties_cb(GtkWidget *widget, gpointer data);
gint destroy_win_error(GtkWidget *widget, gpointer data);
gint close_pop(GtkWidget *widget, gpointer data);
gint scroll_click(GtkWidget *widget, gpointer data);
gint select_proc_clist(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
gint click_clist(GtkWidget *widget, GdkEventButton *event, gpointer data);
gint click_tree(GtkWidget *widget, GdkEventButton *event, gpointer data);
gint select_proc_tree(GtkCTree *tree, GList *node, gint column, gpointer data);
gint prop_tree_choice(GtkWidget *widget, gpointer data);
gint main_btn_clicked(GtkWidget *widget, GdkEventButton *event, gpointer data);
gchar *extract_config_gchar(gchar *fichier, gchar *chaine, gchar *defaut);
void read_gproc_config(void);
void load_default_config(void);
void save_gproc_config(void);
void is_check_help(GtkWidget *widget, gpointer data);

#ifndef APPLET
	gint quit_gproc(GtkWidget *widget,GdkEvent *event,gpointer data);
	void prop_orient_label(void);
	gint prop_orient_choice(GtkWidget *widget, gpointer data);
	gint change_gproc_orient(void);
	gint move_gproc(GtkWidget *widget, GdkEventMotion *ev, gpointer data);
	gint move_clicked(GtkWidget *widget, GdkEventButton *ev, gpointer data);
	gint make_gproc_menu(GdkEventButton *event);
	gint make_label_menu(GtkWidget *widget, GdkEventButton *event, gpointer data);
	gint create_gproc_interface(void);
	gint put_gproc_skin(void);
	gint update_interface_label(gpointer data);
	gint redraw_interface_button(gint status);
	void skin_selected(GtkWidget *clist, gint row, gint column, GdkEventButton *bevent, gpointer data);
	void scan_skins(GtkWidget *clist, gchar *skinsdir);
	void redraw_gproc(void);
	void gproc_pos(void);
	void retreive_gproc_position(void);
#endif
