#include "gproc.h"


/*	button click on/off	*/
gint redraw_interface_button(gint status)
{
	if(prop->orient==ORIENT_VERT)
		gdk_draw_pixmap(app->vdrawbutton->window, app->gcwin,
						(status==TRUE) ? app->vbuttonOnpix : app->vbuttonOffpix,
						0,0,0,0,app->Vbutton_w,app->Vbutton_h);
    else
        gdk_draw_pixmap(app->hdrawbutton->window, app->gcwin,
						(status==TRUE) ? app->hbuttonOnpix : app->hbuttonOffpix,
                        0,0,0,0,app->Hbutton_w,app->Hbutton_h);

	return TRUE;
}

/*  mise a jour du label contenant le nombre de process en cours    */
gint update_interface_label(gpointer data)
{
    gchar *label_text;
	gint long_text;
	gint haut_text;

    label_text=(gchar*)malloc(sizeof(gchar[10]));

    sprintf(label_text,"%d",count_proc());
	long_text=gdk_string_width(app->font, label_text);
	haut_text=gdk_string_height(app->font, label_text);
	
	if(prop->orient==ORIENT_VERT)
	{
		gdk_draw_pixmap(app->vlabelbg, app->gclabel, app->vlabelpix,0,0,0,0,app->Vlabel_w,app->Vlabel_h);
		gdk_draw_string(app->vlabelbg, app->font,app->gclabelbis,
						(app->Vlabel_w-long_text)/2+1+app->Vtext_x,
						(app->Vlabel_h+haut_text)/2+1+app->Vtext_y,
						label_text);
		gdk_draw_string(app->vlabelbg, app->font, app->gclabel,
						(app->Vlabel_w-long_text)/2+app->Vtext_x,
						(app->Vlabel_h+haut_text)/2+app->Vtext_y,
						label_text);

		gdk_draw_pixmap(app->vdrawlabel->window, app->gclabel, app->vlabelbg,0,0,0,0,app->Vlabel_w,app->Vlabel_h);
	}
	else
	{
		gdk_draw_pixmap(app->hlabelbg, app->gclabel, app->hlabelpix,0,0,0,0,app->Hlabel_w,app->Hlabel_h);
        gdk_draw_string(app->hlabelbg, app->font,app->gclabelbis,
						(app->Hlabel_w-long_text)/2+1+app->Htext_x,
						(app->Hlabel_h+haut_text)/2+1+app->Htext_y,
						label_text);
       	gdk_draw_string(app->hlabelbg, app->font, app->gclabel,
						(app->Hlabel_w-long_text)/2+app->Htext_x,
						(app->Hlabel_h+haut_text)/2+app->Htext_y,
						label_text);
		gdk_draw_pixmap(app->hdrawlabel->window, app->gclabel, app->hlabelbg,0,0,0,0,app->Hlabel_w,app->Hlabel_h);
	}
	
	free(label_text);
    label_text=NULL;
    return 1;
}


/* menu principal de gproc */
gint make_gproc_menu(GdkEventButton *event)
{

	GtkWidget   *menu;
    GtkWidget   *button;
	
	menu = gtk_menu_new();

    button = gtk_menu_item_new_with_label("GProc properties");
    gtk_signal_connect(GTK_OBJECT(button), "activate",GTK_SIGNAL_FUNC(properties_cb), NULL);
    gtk_menu_append(GTK_MENU(menu), button);
    gtk_widget_show(button);

	button = gtk_menu_item_new_with_label("Run GTop");
    gtk_signal_connect(GTK_OBJECT(button), "activate",GTK_SIGNAL_FUNC(start_gtop), NULL);
    gtk_menu_append(GTK_MENU(menu), button);
    gtk_widget_show(button);

    
	button = gtk_menu_item_new_with_label("Quit...");
	gtk_signal_connect(GTK_OBJECT (button), "activate",GTK_SIGNAL_FUNC(quit_gproc), NULL);
	gtk_menu_append(GTK_MENU(menu),button);
	gtk_widget_show(button);
	
   	gtk_menu_popup(GTK_MENU(menu),NULL,NULL,NULL,NULL,event->button,event->time);
	
	return TRUE;
}



/* creation menu sur label */
gint make_label_menu(GtkWidget *widget, GdkEventButton *event, gpointer data)
{
	GtkWidget	*menu;
	GtkWidget	*button;
	
	if(event->button==3)
	{
		menu=gtk_menu_new();
		button = gtk_menu_item_new_with_label("Update label NOW !");
		gtk_signal_connect(GTK_OBJECT(button), "activate",GTK_SIGNAL_FUNC(update_interface_label), NULL);
		gtk_menu_append(GTK_MENU(menu), button);
		gtk_widget_show(button);
		
		gtk_menu_popup(GTK_MENU(menu),NULL,NULL,NULL,NULL,event->button,event->time);

		return TRUE;
	}

	return FALSE;

}
		


/* changement d'orientation...*/
gint change_gproc_orient(void)
{
	
	if(prop->orient==ORIENT_VERT)
    {
		gtk_widget_set_usize(app->window,app->Vmwin_w,app->Vmwin_h);
		gtk_widget_hide(app->hmain);
        gtk_widget_show(app->vmain);
		gdk_window_set_back_pixmap((app->window)->window,app->vbg,0);
		gdk_window_shape_combine_mask((app->window)->window,app->Vmwin_mask,0,0);
		gdk_draw_pixmap(app->vbg,app->gcwin,app->vbgpix,0,0,0,0,app->Vmwin_w,app->Vmwin_h);

	}
    else
    {
		gtk_widget_set_usize(app->window,app->Hmwin_w,app->Hmwin_h);
		gtk_widget_hide(app->vmain);
		gtk_widget_show(app->hmain);
		gdk_window_set_back_pixmap((app->window)->window,app->hbg,0);
		gdk_window_shape_combine_mask((app->window)->window,app->Hmwin_mask,0,0);
		gdk_draw_pixmap(app->hbg,app->gcwin,app->hbgpix,0,0,0,0,app->Hmwin_w,app->Hmwin_h);
    }

    return 1;

}

/* deplacement de gproc */
gint move_gproc(GtkWidget *widget, GdkEventMotion *ev, gpointer data)
{
	gint	x, y;
    GdkModifierType m;

	gdk_window_get_pointer(NULL, &x, &y, &m);
	gdk_window_move((app->window)->window,x-x_press,y-y_press);
     
	return 1;
}


/* click sur la zone de move */
gint move_clicked(GtkWidget *widget, GdkEventButton *ev, gpointer data)
{
	
	if(ev->button==3)
		make_gproc_menu(ev);
	else
	{
		x_press=ev->x;
    	y_press=ev->y;
	}
	return 1;
}

/*	lecture def de la skin	*/
gint read_skin_defs(gchar *path)
{
	gchar skin_file[256];
    FILE *file;

	sprintf(skin_file,"%sskin.def",path);
	
	if( (file=fopen(skin_file,"r"))==NULL)
    {
    	
		g_print("Cannot read GProc skin file (%s). -> Trying to use default skin...\n",skin_file);
		prop->skin_path=strdup( GPROC_DIR "skins/Default/");
		sprintf(skin_file, GPROC_DIR "skins/Default/skin.def");

		if( (file=fopen(skin_file,"r"))==NULL)
		{
			g_print("Default skin.def not found. Please check GProc installation\n");
			exit(-1);
		}
	}	
	else
    	fclose(file);
	
	app->Hmwin_w=atoi(extract_config_gchar(skin_file,"Hmwin_w","110"));
	app->Hmwin_h=atoi(extract_config_gchar(skin_file,"Hmwin_h","28"));
	app->Hbutton_w=atoi(extract_config_gchar(skin_file,"Hbutton_w","14"));
	app->Hbutton_h=atoi(extract_config_gchar(skin_file,"Hbutton_h","14"));
	app->Hlabel_w=atoi(extract_config_gchar(skin_file,"Hlabel_w","46"));
	app->Hlabel_h=atoi(extract_config_gchar(skin_file,"Hlabel_h","16"));
	app->Vmwin_w=atoi(extract_config_gchar(skin_file,"Vmwin_w","48"));
    app->Vmwin_h=atoi(extract_config_gchar(skin_file,"Vmwin_h","48"));
    app->Vbutton_w=atoi(extract_config_gchar(skin_file,"Vbutton_w","14"));
    app->Vbutton_h=atoi(extract_config_gchar(skin_file,"Vbutton_h","14"));
	app->Vlabel_w=atoi(extract_config_gchar(skin_file,"Vlabel_w","44"));
    app->Vlabel_h=atoi(extract_config_gchar(skin_file,"Vlabel_h","13"));
	app->Htext_x=atoi(extract_config_gchar(skin_file,"Htext_x","0"));
	app->Htext_y=atoi(extract_config_gchar(skin_file,"Htext_y","0"));
	app->Vtext_x=atoi(extract_config_gchar(skin_file,"Vtext_x","0"));
    app->Vtext_y=atoi(extract_config_gchar(skin_file,"Vtext_y","0"));
	app->Hsep1=atoi(extract_config_gchar(skin_file,"Hsep1","0"));
	app->Hsep2=atoi(extract_config_gchar(skin_file,"Hsep2","1"));
	app->Hsep3=atoi(extract_config_gchar(skin_file,"Hsep3","0"));
	app->Vsep1=atoi(extract_config_gchar(skin_file,"Vsep1","0"));
    app->Vsep2=atoi(extract_config_gchar(skin_file,"Vsep2","4"));
    app->Vsep3=atoi(extract_config_gchar(skin_file,"Vsep3","5"));
	app->font_string=extract_config_gchar(skin_file,"font","-adobe-courier-medium-r-*-*-*-100-*-*-*-*-*-*");
	app->font_color_str=extract_config_gchar(skin_file,"font_color","#FFFFFF");
	app->font_shadow_str=extract_config_gchar(skin_file,"font_shadow_color","#000000");
	
	return TRUE;
}

/*	chemin d'une image	*/
gchar *pix_path(gchar *pix)
{
	 gchar path[255];
	 sprintf(path,"%s%s",prop->skin_path,pix);
	 return strdup(path);
}

/*	interface independante de gproc	*/
gint create_gproc_interface(void)
{
	GdkPixmap *pix;
	GdkBitmap *mask;
	
	/*	fenetre principale	*/
	app->window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_uposition(app->window,prop->posX,prop->posY);
	gtk_widget_set_app_paintable(app->window, TRUE);
	gtk_widget_realize(app->window);
	gtk_window_set_policy(GTK_WINDOW(app->window),FALSE,FALSE,TRUE);
    gdk_window_set_decorations((app->window)->window,0);
	pix=gdk_pixmap_create_from_xpm((app->window)->window,&mask,NULL, GPROC_DIR "icons/gproc-icon.xpm");
	gdk_window_set_icon(app->window->window,NULL,pix,mask);
	gtk_widget_set_name(app->window,"GProc");
	gtk_signal_connect(GTK_OBJECT(app->window),"delete_event",GTK_SIGNAL_FUNC(quit_gproc),NULL);
	read_skin_defs(prop->skin_path);
	
	put_gproc_skin();
	
	gtk_widget_show(app->window);

	return TRUE;
}

/* applique les elements de la skin */
gint put_gproc_skin(void)
{
	
	GtkWidget *base;
	GtkWidget *sep;
	GtkWidget *hmove;
	GtkWidget *vmove;
	GtkWidget *hevent, *vevent;
	GtkWidget *pic;
	GdkPixmap *pix;
	GdkBitmap *mask;
	GdkColormap *colormap;
	GtkWidget *vbox,*hbox;
	
	/*	background	*/
	app->gcwin=gdk_gc_new((app->window)->window);
	app->hbg=gdk_pixmap_new((app->window)->window, app->Hmwin_w, app->Hmwin_h, gdk_visual_get_best_depth());
	app->vbg=gdk_pixmap_new((app->window)->window, app->Vmwin_w, app->Vmwin_h, gdk_visual_get_best_depth());
	app->hbgpix=gdk_pixmap_create_from_xpm((app->window)->window,&(app->Hmwin_mask),NULL,pix_path("hback.xpm"));
	app->vbgpix=gdk_pixmap_create_from_xpm((app->window)->window,&(app->Vmwin_mask),NULL,pix_path("vback.xpm")); 
	
	/*  Main boite  */
    base=gtk_vbox_new(FALSE,0);
    gtk_widget_show(base);
	gtk_container_add(GTK_CONTAINER(app->window),base);
	

	/*	boites principales	*/
	app->hmain=gtk_hbox_new(FALSE,0);
	app->vmain=gtk_vbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(base),app->hmain,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(base),app->vmain,FALSE,FALSE,0);
	

	/*  separateur  */
    sep=gtk_hbox_new(FALSE,0);
    gtk_widget_set_usize(sep,app->Hsep1,0);
    gtk_box_pack_start(GTK_BOX(app->hmain),sep,FALSE,FALSE,0);
    gtk_widget_show(sep);
    sep=gtk_vbox_new(FALSE,0);
    gtk_widget_set_usize(sep,0,app->Vsep1);
    gtk_box_pack_start(GTK_BOX(app->vmain),sep,FALSE,FALSE,0);
    gtk_widget_show(sep);

	
	/*	move	*/
	hevent=gtk_event_box_new();
	gtk_widget_show(hevent);
	vevent=gtk_event_box_new();
	gtk_widget_show(vevent);
	hmove=gtk_hbox_new(FALSE,0);
	gtk_widget_show(hmove);
	vmove=gtk_vbox_new(FALSE,0);
	gtk_widget_show(vmove);
	
	pix=gdk_pixmap_create_from_xpm((app->window)->window,&mask,NULL,pix_path("hmove.xpm"));
    pic=gtk_pixmap_new(pix,mask);
    gtk_widget_show(pic);
    gtk_box_pack_start(GTK_BOX(hmove),pic,FALSE,FALSE,0);

    pix=gdk_pixmap_create_from_xpm((app->window)->window,&mask,NULL,pix_path("vmove.xpm"));
    pic=gtk_pixmap_new(pix,mask);
    gtk_widget_show(pic);
    gtk_box_pack_start(GTK_BOX(vmove),pic,FALSE,FALSE,0);

	gtk_container_add(GTK_CONTAINER(hevent),hmove);
    gtk_container_add(GTK_CONTAINER(vevent),vmove);
	gtk_box_pack_start(GTK_BOX(app->hmain),hevent,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(app->vmain),vevent,FALSE,FALSE,0);

	gtk_signal_connect(GTK_OBJECT(hevent), "button_press_event",GTK_SIGNAL_FUNC(move_clicked), NULL );
    gtk_signal_connect(GTK_OBJECT(vevent), "button_press_event",GTK_SIGNAL_FUNC(move_clicked), NULL );
    gtk_signal_connect(GTK_OBJECT(hevent), "motion_notify_event", GTK_SIGNAL_FUNC(move_gproc), NULL);
    gtk_signal_connect(GTK_OBJECT(vevent), "motion_notify_event", GTK_SIGNAL_FUNC(move_gproc), NULL);


	/*	separateur	*/
	sep=gtk_hbox_new(TRUE,0);
	gtk_widget_set_usize(sep,app->Hsep2,0);
	gtk_box_pack_start(GTK_BOX(app->hmain),sep,FALSE,FALSE,0);
	gtk_widget_show(sep);
	sep=gtk_vbox_new(FALSE,0);
    gtk_widget_set_usize(sep,0,app->Vsep2);
    gtk_box_pack_start(GTK_BOX(app->vmain),sep,FALSE,FALSE,0);
	gtk_widget_show(sep);
	
	/*	button	*/
	hbox=gtk_vbox_new(FALSE,0);
    gtk_widget_show(hbox);
    gtk_box_pack_start(GTK_BOX(app->hmain), hbox, TRUE, FALSE, 0);
	vbox=gtk_hbox_new(FALSE,0);
    gtk_widget_show(vbox);
    gtk_box_pack_start(GTK_BOX(app->vmain), vbox, TRUE, FALSE, 0);
	
	hevent=gtk_event_box_new();
	gtk_widget_show(hevent);
	gtk_box_pack_start(GTK_BOX(hbox),hevent,TRUE,FALSE,0);
	vevent=gtk_event_box_new();
	gtk_widget_show(vevent);
	gtk_box_pack_start(GTK_BOX(vbox),vevent,TRUE,FALSE,0);

    app->hdrawbutton=gtk_drawing_area_new();
    gtk_drawing_area_size(GTK_DRAWING_AREA(app->hdrawbutton),app->Hbutton_w,app->Hbutton_h);
  	gtk_container_add(GTK_CONTAINER(hevent), app->hdrawbutton);
	gtk_widget_show(app->hdrawbutton);
    app->vdrawbutton=gtk_drawing_area_new();
    gtk_drawing_area_size(GTK_DRAWING_AREA(app->vdrawbutton),app->Vbutton_w,app->Vbutton_h);
 	gtk_container_add(GTK_CONTAINER(vevent), app->vdrawbutton);
    gtk_widget_show(app->vdrawbutton);

    gtk_signal_connect(GTK_OBJECT(hevent), "button_press_event",GTK_SIGNAL_FUNC(main_btn_clicked), NULL );
    gtk_signal_connect(GTK_OBJECT(vevent), "button_press_event",GTK_SIGNAL_FUNC(main_btn_clicked), NULL );

	app->hbuttonOffpix=gdk_pixmap_create_from_xpm((app->hdrawbutton)->window,&mask,NULL,pix_path("hbutton.xpm"));
    app->vbuttonOffpix=gdk_pixmap_create_from_xpm((app->vdrawbutton)->window,&mask,NULL,pix_path("vbutton.xpm"));
	app->hbuttonOnpix=gdk_pixmap_create_from_xpm((app->hdrawbutton)->window,&mask,NULL,pix_path("hbutton_press.xpm"));
    app->vbuttonOnpix=gdk_pixmap_create_from_xpm((app->vdrawbutton)->window,&mask,NULL,pix_path("vbutton_press.xpm"));

	
	gdk_window_set_back_pixmap((app->hdrawbutton)->window,app->hbuttonOffpix,0);
	gdk_window_set_back_pixmap((app->vdrawbutton)->window,app->vbuttonOffpix,0);
	
		
	 /*  separateur  */
    sep=gtk_hbox_new(FALSE,0);
    gtk_widget_set_usize(sep,app->Hsep3,0);
	gtk_box_pack_start(GTK_BOX(app->hmain),sep,FALSE,FALSE,0);
    gtk_widget_show(sep);
    sep=gtk_vbox_new(FALSE,0);
    gtk_widget_set_usize(sep,0,app->Vsep3);
    gtk_box_pack_start(GTK_BOX(app->vmain),sep,FALSE,FALSE,0);
    gtk_widget_show(sep);


	
	/*	label	*/
	hbox=gtk_vbox_new(FALSE,0);
    gtk_widget_show(hbox);
    gtk_box_pack_start(GTK_BOX(app->hmain), hbox, TRUE, FALSE, 0);
	vbox=gtk_hbox_new(FALSE,0);
    gtk_widget_show(vbox);
    gtk_box_pack_start(GTK_BOX(app->vmain), vbox, TRUE, FALSE, 0);
	
	hevent=gtk_event_box_new();
	gtk_widget_show(hevent);
	gtk_box_pack_start(GTK_BOX(hbox),hevent,TRUE,FALSE,0);
	vevent=gtk_event_box_new();
	gtk_widget_show(vevent);
	gtk_box_pack_start(GTK_BOX(vbox),vevent,TRUE,FALSE,0);

	gtk_signal_connect(GTK_OBJECT(hevent), "button_press_event",GTK_SIGNAL_FUNC(make_label_menu), NULL );
    gtk_signal_connect(GTK_OBJECT(vevent), "button_press_event",GTK_SIGNAL_FUNC(make_label_menu), NULL );
	
	app->hdrawlabel=gtk_drawing_area_new();
	gtk_drawing_area_size(GTK_DRAWING_AREA(app->hdrawlabel),app->Hlabel_w,app->Hlabel_h);
	gtk_container_add(GTK_CONTAINER(hevent), app->hdrawlabel);
	gtk_widget_show(app->hdrawlabel);
	app->vdrawlabel=gtk_drawing_area_new();
	gtk_drawing_area_size(GTK_DRAWING_AREA(app->vdrawlabel),app->Vlabel_w,app->Vlabel_h);
	gtk_container_add(GTK_CONTAINER(vevent), app->vdrawlabel);
	gtk_widget_show(app->vdrawlabel);

	app->gclabel=gdk_gc_new(app->window->window);
	gdk_gc_copy(app->gclabel,(app->window)->style->white_gc);
	app->gclabelbis=gdk_gc_new(app->window->window);
    gdk_gc_copy(app->gclabelbis,(app->window)->style->white_gc);

	colormap=gtk_widget_get_colormap(app->window);
    gdk_color_parse(app->font_color_str,&(app->font_color));
    gdk_color_alloc(colormap,&(app->font_color));
	gdk_color_parse(app->font_shadow_str,&(app->font_colorbis));
    gdk_color_alloc(colormap,&(app->font_colorbis));
	
	app->font=gdk_font_load(app->font_string);
	
	app->hlabelpix=gdk_pixmap_create_from_xpm((app->hdrawlabel)->window,&mask,NULL,pix_path("hlabel.xpm"));
	app->hlabelbg=gdk_pixmap_create_from_xpm((app->hdrawlabel)->window,&mask,NULL,pix_path("hlabel.xpm"));
	app->vlabelpix=gdk_pixmap_create_from_xpm((app->vdrawlabel)->window,&mask,NULL,pix_path("vlabel.xpm"));
	app->vlabelbg=gdk_pixmap_create_from_xpm((app->vdrawlabel)->window,&mask,NULL,pix_path("vlabel.xpm"));

	gdk_gc_set_foreground(app->gclabel, &(app->font_color));
	gdk_gc_set_foreground(app->gclabelbis, &(app->font_colorbis));

	gdk_window_set_back_pixmap((app->hdrawlabel)->window,app->hlabelbg,0);
    gdk_window_set_back_pixmap((app->vdrawlabel)->window,app->vlabelbg,0);
	

	change_gproc_orient();
	
	/*	force affichage button, parait qu'il y avait des pbs 
	 	TODO voir avec les anciennes version de gdk-imlib */
	redraw_interface_button(popup_open);	
	return TRUE;
}

/*	position gproc	*/
void gproc_pos(void)
{
    gdk_window_get_deskrelative_origin(app->window->window,&(prop->posX), &(prop->posY));
}

/*	sortie de gproc	*/
gint quit_gproc(GtkWidget *widget,GdkEvent *event,gpointer data)
{
	save_gproc_config();
	gtk_main_quit();
	return 0;
}

/*	redraw gproc	*/
void redraw_gproc(void)
{
	gproc_pos();
	gtk_timeout_remove(timer_label);
	
	/* FIXME cleanup pas tres efficace */
	if(app->hdrawbutton)
	{
		gtk_widget_destroy(app->hdrawbutton);
		app->hdrawbutton=NULL;
	}
	if(app->vdrawbutton)
	{
		gtk_widget_destroy(app->vdrawbutton);
		app->vdrawbutton=NULL;
	}
	if(app->hdrawlabel)
	{
		gtk_widget_destroy(app->hdrawlabel);
		app->hdrawlabel=NULL;
	}
	if(app->vdrawlabel)
	{
		gtk_widget_destroy(app->vdrawlabel);
		app->vdrawlabel=NULL;
	}
	if(app->hbg)
	{
		gdk_pixmap_unref(app->hbg);
		app->hbg=NULL;
	}
	if(app->vbg)
	{
		gdk_pixmap_unref(app->vbg);
		app->vbg=NULL;
	}
	if(app->vbgpix)
	{
		gdk_pixmap_unref(app->vbgpix);
		app->vbgpix=NULL;
	}
	if(app->hbgpix)
	{
		gdk_pixmap_unref(app->hbgpix);
		app->hbgpix=NULL;
	}
	if(app->gcwin)
	{
		gdk_gc_unref(app->gcwin);
		app->gcwin=NULL;
	}
	if(app->gclabel)
	{
		gdk_gc_unref(app->gclabel);
		app->gclabel=NULL;
	}
	if(app->gclabelbis)
	{
		gdk_gc_unref(app->gclabelbis);
		app->gclabelbis=NULL;
	}
	if(app->hlabelbg)
	{
		gdk_pixmap_unref(app->hlabelbg);
		app->hlabelbg=NULL;
	}
	if(app->vlabelbg)
	{
		gdk_pixmap_unref(app->vlabelbg);
		app->vlabelbg=NULL;
	}
	if(app->hlabelpix)
	{
		gdk_pixmap_unref(app->hlabelpix);
		app->hlabelpix=NULL;
	}
	if(app->vlabelpix)
	{
		gdk_pixmap_unref(app->vlabelpix);
		app->vlabelpix=NULL;
	}
	if(app->hbuttonOnpix)
	{
		gdk_pixmap_unref(app->hbuttonOnpix);
		app->hbuttonOnpix=NULL;
	}
	if(app->vbuttonOnpix)
	{
		gdk_pixmap_unref(app->vbuttonOnpix);
		app->vbuttonOnpix=NULL;
	}
	if(app->hbuttonOffpix)
	{
		gdk_pixmap_unref(app->hbuttonOffpix);
		app->hbuttonOffpix=NULL;
	}
	if(app->vbuttonOffpix)
	{
		gdk_pixmap_unref(app->vbuttonOffpix);
		app->vbuttonOffpix=NULL;
	}
	if(app->Hmwin_mask)
	{
		gdk_bitmap_unref(app->Hmwin_mask);
		app->Hmwin_mask=NULL;
	}
	if(app->Vmwin_mask)
	{
		gdk_bitmap_unref(app->Vmwin_mask);
		app->Vmwin_mask=NULL;
	}
	if(app->vmain)
	{
		gtk_widget_destroy(app->vmain);
		app->vmain=NULL;
	}
	if(app->hmain)
	{
		gtk_widget_destroy(app->hmain);
		app->hmain=NULL;
	}
	if(app->window)
	{
		gtk_widget_destroy(app->window);
		app->window=NULL;
	}

	g_free(app->font_string);
	app->font_string=NULL;
	g_free(app->font_color_str);
	app->font_color_str=NULL;
	g_free(app->font_shadow_str);
	app->font_shadow_str=NULL;
	g_free(app);
	app=NULL;
	app=g_new(AppletWid,1);
	create_gproc_interface();
	timer_label=gtk_timeout_add((prop->refresh_label)*1000,update_interface_label,NULL);

}


